! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Parameter Module File
! 
! Generated by KPP-2.2.1_rs5 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : SUAQ_messy_mecca_kpp_Parameters.f90
! Time                 : Tue Jan 23 13:18:01 2018
! Working directory    : /gpfs/projects/bsc32/bsc32771/MN3/NMMB/test/KPP/caaba_3.0gmdd/mecca
! Equation file        : SUAQ_messy_mecca_kpp.kpp
! Output root filename : SUAQ_messy_mecca_kpp
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE SUAQ_messy_mecca_kpp_Parameters

  USE SUAQ_messy_mecca_kpp_Precision
  PUBLIC
  SAVE


! NSPEC - Number of chemical species
  INTEGER, PARAMETER :: NSPEC = 16 
! NVAR - Number of Variable species
  INTEGER, PARAMETER :: NVAR = 15 
! NVARACT - Number of Active species
  INTEGER, PARAMETER :: NVARACT = 11 
! NFIX - Number of Fixed species
  INTEGER, PARAMETER :: NFIX = 1 
! NREACT - Number of reactions
  INTEGER, PARAMETER :: NREACT = 16 
! NVARST - Starting of variables in conc. vect.
  INTEGER, PARAMETER :: NVARST = 1 
! NFIXST - Starting of fixed in conc. vect.
  INTEGER, PARAMETER :: NFIXST = 16 
! NONZERO - Number of nonzero entries in Jacobian
  INTEGER, PARAMETER :: NONZERO = 47 
! LU_NONZERO - Number of nonzero entries in LU factoriz. of Jacobian
  INTEGER, PARAMETER :: LU_NONZERO = 47 
! CNVAR - (NVAR+1) Number of elements in compressed row format
  INTEGER, PARAMETER :: CNVAR = 16 
! NLOOKAT - Number of species to look at
  INTEGER, PARAMETER :: NLOOKAT = 0 
! NMONITOR - Number of species to monitor
  INTEGER, PARAMETER :: NMONITOR = 0 
! NMASS - Number of atoms to check mass balance
  INTEGER, PARAMETER :: NMASS = 1 

! Index declaration for variable species in C and VAR
!   VAR(ind_spc) = C(ind_spc)

  INTEGER, PARAMETER :: ind_N2O5 = 1 
  INTEGER, PARAMETER :: ind_DMS = 2 
  INTEGER, PARAMETER :: ind_HO2 = 3 
  INTEGER, PARAMETER :: ind_NO3m_cs = 4 
  INTEGER, PARAMETER :: ind_Hp_cs = 5 
  INTEGER, PARAMETER :: ind_SO4mm_a01 = 6 
  INTEGER, PARAMETER :: ind_O3 = 7 
  INTEGER, PARAMETER :: ind_SO2 = 8 
  INTEGER, PARAMETER :: ind_H2O2 = 9 
  INTEGER, PARAMETER :: ind_H2O2_a01 = 10 
  INTEGER, PARAMETER :: ind_SO2_a01 = 11 
  INTEGER, PARAMETER :: ind_Hp_a01 = 12 
  INTEGER, PARAMETER :: ind_HSO3m_a01 = 13 
  INTEGER, PARAMETER :: ind_SO3mm_a01 = 14 
  INTEGER, PARAMETER :: ind_O3_a01 = 15 

! Index declaration for fixed species in C
!   C(ind_spc)

  INTEGER, PARAMETER :: ind_OH = 16 

! Index declaration for dummy species

  INTEGER, PARAMETER :: ind_O1D = 0 
  INTEGER, PARAMETER :: ind_O3P = 0 
  INTEGER, PARAMETER :: ind_O2 = 0 
  INTEGER, PARAMETER :: ind_H = 0 
  INTEGER, PARAMETER :: ind_H2 = 0 
  INTEGER, PARAMETER :: ind_H2O = 0 
  INTEGER, PARAMETER :: ind_N = 0 
  INTEGER, PARAMETER :: ind_N2 = 0 
  INTEGER, PARAMETER :: ind_NH3 = 0 
  INTEGER, PARAMETER :: ind_N2O = 0 
  INTEGER, PARAMETER :: ind_NO = 0 
  INTEGER, PARAMETER :: ind_NO2 = 0 
  INTEGER, PARAMETER :: ind_NO3 = 0 
  INTEGER, PARAMETER :: ind_HONO = 0 
  INTEGER, PARAMETER :: ind_HNO3 = 0 
  INTEGER, PARAMETER :: ind_HNO4 = 0 
  INTEGER, PARAMETER :: ind_NH2 = 0 
  INTEGER, PARAMETER :: ind_HNO = 0 
  INTEGER, PARAMETER :: ind_NHOH = 0 
  INTEGER, PARAMETER :: ind_NH2O = 0 
  INTEGER, PARAMETER :: ind_NH2OH = 0 
  INTEGER, PARAMETER :: ind_CH3O2 = 0 
  INTEGER, PARAMETER :: ind_CH3OH = 0 
  INTEGER, PARAMETER :: ind_CH3OOH = 0 
  INTEGER, PARAMETER :: ind_CH4 = 0 
  INTEGER, PARAMETER :: ind_CO = 0 
  INTEGER, PARAMETER :: ind_CO2 = 0 
  INTEGER, PARAMETER :: ind_HCHO = 0 
  INTEGER, PARAMETER :: ind_HCOOH = 0 
  INTEGER, PARAMETER :: ind_LCARBON = 0 
  INTEGER, PARAMETER :: ind_C2H2 = 0 
  INTEGER, PARAMETER :: ind_C2H4 = 0 
  INTEGER, PARAMETER :: ind_C2H5O2 = 0 
  INTEGER, PARAMETER :: ind_C2H5OOH = 0 
  INTEGER, PARAMETER :: ind_C2H6 = 0 
  INTEGER, PARAMETER :: ind_CH3CHO = 0 
  INTEGER, PARAMETER :: ind_CH3CO2H = 0 
  INTEGER, PARAMETER :: ind_CH3CO3 = 0 
  INTEGER, PARAMETER :: ind_CH3CO3H = 0 
  INTEGER, PARAMETER :: ind_ETHGLY = 0 
  INTEGER, PARAMETER :: ind_ETHOHNO3 = 0 
  INTEGER, PARAMETER :: ind_GLYOX = 0 
  INTEGER, PARAMETER :: ind_HCOCO2H = 0 
  INTEGER, PARAMETER :: ind_HCOCO3 = 0 
  INTEGER, PARAMETER :: ind_HCOCO3H = 0 
  INTEGER, PARAMETER :: ind_HOCH2CH2O = 0 
  INTEGER, PARAMETER :: ind_HOCH2CH2O2 = 0 
  INTEGER, PARAMETER :: ind_HOCH2CHO = 0 
  INTEGER, PARAMETER :: ind_HOCH2CO2H = 0 
  INTEGER, PARAMETER :: ind_HOCH2CO3 = 0 
  INTEGER, PARAMETER :: ind_HOCH2CO3H = 0 
  INTEGER, PARAMETER :: ind_HYETHO2H = 0 
  INTEGER, PARAMETER :: ind_PAN = 0 
  INTEGER, PARAMETER :: ind_PHAN = 0 
  INTEGER, PARAMETER :: ind_ACETOL = 0 
  INTEGER, PARAMETER :: ind_C3H6 = 0 
  INTEGER, PARAMETER :: ind_C3H8 = 0 
  INTEGER, PARAMETER :: ind_CH3COCH2O2 = 0 
  INTEGER, PARAMETER :: ind_CH3COCH3 = 0 
  INTEGER, PARAMETER :: ind_HOCH2COCHO = 0 
  INTEGER, PARAMETER :: ind_HOCH2COCO2H = 0 
  INTEGER, PARAMETER :: ind_HYPERACET = 0 
  INTEGER, PARAMETER :: ind_HYPROPO2 = 0 
  INTEGER, PARAMETER :: ind_HYPROPO2H = 0 
  INTEGER, PARAMETER :: ind_IC3H7NO3 = 0 
  INTEGER, PARAMETER :: ind_IC3H7O2 = 0 
  INTEGER, PARAMETER :: ind_IC3H7OOH = 0 
  INTEGER, PARAMETER :: ind_MGLYOX = 0 
  INTEGER, PARAMETER :: ind_NOA = 0 
  INTEGER, PARAMETER :: ind_PR2O2HNO3 = 0 
  INTEGER, PARAMETER :: ind_PRONO3BO2 = 0 
  INTEGER, PARAMETER :: ind_BIACET = 0 
  INTEGER, PARAMETER :: ind_BIACETOH = 0 
  INTEGER, PARAMETER :: ind_CO2H3CHO = 0 
  INTEGER, PARAMETER :: ind_CO2H3CO3 = 0 
  INTEGER, PARAMETER :: ind_CO2H3CO3H = 0 
  INTEGER, PARAMETER :: ind_HO12CO3C4 = 0 
  INTEGER, PARAMETER :: ind_LC4H9NO3 = 0 
  INTEGER, PARAMETER :: ind_LC4H9O2 = 0 
  INTEGER, PARAMETER :: ind_LC4H9OOH = 0 
  INTEGER, PARAMETER :: ind_LHMVKABO2 = 0 
  INTEGER, PARAMETER :: ind_LHMVKABOOH = 0 
  INTEGER, PARAMETER :: ind_LMVKOHABO2 = 0 
  INTEGER, PARAMETER :: ind_LMVKOHABOOH = 0 
  INTEGER, PARAMETER :: ind_MACO2H = 0 
  INTEGER, PARAMETER :: ind_MACO3 = 0 
  INTEGER, PARAMETER :: ind_MACO3H = 0 
  INTEGER, PARAMETER :: ind_MACR = 0 
  INTEGER, PARAMETER :: ind_MACRO2 = 0 
  INTEGER, PARAMETER :: ind_MACROH = 0 
  INTEGER, PARAMETER :: ind_MACROOH = 0 
  INTEGER, PARAMETER :: ind_MEK = 0 
  INTEGER, PARAMETER :: ind_LMEKO2 = 0 
  INTEGER, PARAMETER :: ind_LMEKOOH = 0 
  INTEGER, PARAMETER :: ind_MPAN = 0 
  INTEGER, PARAMETER :: ind_MVK = 0 
  INTEGER, PARAMETER :: ind_MVKOH = 0 
  INTEGER, PARAMETER :: ind_NC4H10 = 0 
  INTEGER, PARAMETER :: ind_C59O2 = 0 
  INTEGER, PARAMETER :: ind_C59OOH = 0 
  INTEGER, PARAMETER :: ind_C5H8 = 0 
  INTEGER, PARAMETER :: ind_HCOC5 = 0 
  INTEGER, PARAMETER :: ind_ISOPAOH = 0 
  INTEGER, PARAMETER :: ind_ISOPBNO3 = 0 
  INTEGER, PARAMETER :: ind_ISOPBO2 = 0 
  INTEGER, PARAMETER :: ind_ISOPBOH = 0 
  INTEGER, PARAMETER :: ind_ISOPBOOH = 0 
  INTEGER, PARAMETER :: ind_ISOPDNO3 = 0 
  INTEGER, PARAMETER :: ind_ISOPDO2 = 0 
  INTEGER, PARAMETER :: ind_ISOPDOH = 0 
  INTEGER, PARAMETER :: ind_ISOPDOOH = 0 
  INTEGER, PARAMETER :: ind_LC578O2 = 0 
  INTEGER, PARAMETER :: ind_LC578OOH = 0 
  INTEGER, PARAMETER :: ind_LC5PAN1719 = 0 
  INTEGER, PARAMETER :: ind_LHC4ACCHO = 0 
  INTEGER, PARAMETER :: ind_LHC4ACCO2H = 0 
  INTEGER, PARAMETER :: ind_LHC4ACCO3 = 0 
  INTEGER, PARAMETER :: ind_LHC4ACCO3H = 0 
  INTEGER, PARAMETER :: ind_LISOPACNO3 = 0 
  INTEGER, PARAMETER :: ind_LISOPACO2 = 0 
  INTEGER, PARAMETER :: ind_LISOPACOOH = 0 
  INTEGER, PARAMETER :: ind_LNISO3 = 0 
  INTEGER, PARAMETER :: ind_LNISOOH = 0 
  INTEGER, PARAMETER :: ind_NC4CHO = 0 
  INTEGER, PARAMETER :: ind_NISOPO2 = 0 
  INTEGER, PARAMETER :: ind_NISOPOOH = 0 
  INTEGER, PARAMETER :: ind_Cl = 0 
  INTEGER, PARAMETER :: ind_Cl2 = 0 
  INTEGER, PARAMETER :: ind_ClO = 0 
  INTEGER, PARAMETER :: ind_HCl = 0 
  INTEGER, PARAMETER :: ind_HOCl = 0 
  INTEGER, PARAMETER :: ind_Cl2O2 = 0 
  INTEGER, PARAMETER :: ind_OClO = 0 
  INTEGER, PARAMETER :: ind_ClNO2 = 0 
  INTEGER, PARAMETER :: ind_ClNO3 = 0 
  INTEGER, PARAMETER :: ind_CCl4 = 0 
  INTEGER, PARAMETER :: ind_CH3Cl = 0 
  INTEGER, PARAMETER :: ind_CH3CCl3 = 0 
  INTEGER, PARAMETER :: ind_CF2Cl2 = 0 
  INTEGER, PARAMETER :: ind_CFCl3 = 0 
  INTEGER, PARAMETER :: ind_Br = 0 
  INTEGER, PARAMETER :: ind_Br2 = 0 
  INTEGER, PARAMETER :: ind_BrO = 0 
  INTEGER, PARAMETER :: ind_HBr = 0 
  INTEGER, PARAMETER :: ind_HOBr = 0 
  INTEGER, PARAMETER :: ind_BrNO2 = 0 
  INTEGER, PARAMETER :: ind_BrNO3 = 0 
  INTEGER, PARAMETER :: ind_BrCl = 0 
  INTEGER, PARAMETER :: ind_CH3Br = 0 
  INTEGER, PARAMETER :: ind_CF3Br = 0 
  INTEGER, PARAMETER :: ind_CF2ClBr = 0 
  INTEGER, PARAMETER :: ind_CHCl2Br = 0 
  INTEGER, PARAMETER :: ind_CHClBr2 = 0 
  INTEGER, PARAMETER :: ind_CH2ClBr = 0 
  INTEGER, PARAMETER :: ind_CH2Br2 = 0 
  INTEGER, PARAMETER :: ind_CHBr3 = 0 
  INTEGER, PARAMETER :: ind_I = 0 
  INTEGER, PARAMETER :: ind_I2 = 0 
  INTEGER, PARAMETER :: ind_IO = 0 
  INTEGER, PARAMETER :: ind_OIO = 0 
  INTEGER, PARAMETER :: ind_I2O2 = 0 
  INTEGER, PARAMETER :: ind_HI = 0 
  INTEGER, PARAMETER :: ind_HOI = 0 
  INTEGER, PARAMETER :: ind_HIO3 = 0 
  INTEGER, PARAMETER :: ind_INO2 = 0 
  INTEGER, PARAMETER :: ind_INO3 = 0 
  INTEGER, PARAMETER :: ind_CH3I = 0 
  INTEGER, PARAMETER :: ind_CH2I2 = 0 
  INTEGER, PARAMETER :: ind_C3H7I = 0 
  INTEGER, PARAMETER :: ind_ICl = 0 
  INTEGER, PARAMETER :: ind_CH2ClI = 0 
  INTEGER, PARAMETER :: ind_IBr = 0 
  INTEGER, PARAMETER :: ind_S = 0 
  INTEGER, PARAMETER :: ind_SO = 0 
  INTEGER, PARAMETER :: ind_SH = 0 
  INTEGER, PARAMETER :: ind_H2SO4 = 0 
  INTEGER, PARAMETER :: ind_CH3SO3H = 0 
  INTEGER, PARAMETER :: ind_DMSO = 0 
  INTEGER, PARAMETER :: ind_CH3SO2 = 0 
  INTEGER, PARAMETER :: ind_CH3SO3 = 0 
  INTEGER, PARAMETER :: ind_OCS = 0 
  INTEGER, PARAMETER :: ind_SF6 = 0 
  INTEGER, PARAMETER :: ind_Hg = 0 
  INTEGER, PARAMETER :: ind_HgO = 0 
  INTEGER, PARAMETER :: ind_HgCl = 0 
  INTEGER, PARAMETER :: ind_HgCl2 = 0 
  INTEGER, PARAMETER :: ind_HgBr = 0 
  INTEGER, PARAMETER :: ind_HgBr2 = 0 
  INTEGER, PARAMETER :: ind_ClHgBr = 0 
  INTEGER, PARAMETER :: ind_BrHgOBr = 0 
  INTEGER, PARAMETER :: ind_ClHgOBr = 0 
  INTEGER, PARAMETER :: ind_RGM_cs = 0 
  INTEGER, PARAMETER :: ind_IPART = 0 
  INTEGER, PARAMETER :: ind_Dummy = 0 
  INTEGER, PARAMETER :: ind_O3s = 0 
  INTEGER, PARAMETER :: ind_LO3s = 0 
  INTEGER, PARAMETER :: ind_LHOC3H6O2 = 0 
  INTEGER, PARAMETER :: ind_LHOC3H6OOH = 0 
  INTEGER, PARAMETER :: ind_ISO2 = 0 
  INTEGER, PARAMETER :: ind_ISON = 0 
  INTEGER, PARAMETER :: ind_ISOOH = 0 
  INTEGER, PARAMETER :: ind_MVKO2 = 0 
  INTEGER, PARAMETER :: ind_MVKOOH = 0 
  INTEGER, PARAMETER :: ind_NACA = 0 
  INTEGER, PARAMETER :: ind_O2_a01 = 0 
  INTEGER, PARAMETER :: ind_OH_a01 = 0 
  INTEGER, PARAMETER :: ind_HO2_a01 = 0 
  INTEGER, PARAMETER :: ind_H2O_a01 = 0 
  INTEGER, PARAMETER :: ind_NH3_a01 = 0 
  INTEGER, PARAMETER :: ind_NO_a01 = 0 
  INTEGER, PARAMETER :: ind_NO2_a01 = 0 
  INTEGER, PARAMETER :: ind_NO3_a01 = 0 
  INTEGER, PARAMETER :: ind_HONO_a01 = 0 
  INTEGER, PARAMETER :: ind_HNO3_a01 = 0 
  INTEGER, PARAMETER :: ind_HNO4_a01 = 0 
  INTEGER, PARAMETER :: ind_N2O5_a01 = 0 
  INTEGER, PARAMETER :: ind_CH3OH_a01 = 0 
  INTEGER, PARAMETER :: ind_HCOOH_a01 = 0 
  INTEGER, PARAMETER :: ind_HCHO_a01 = 0 
  INTEGER, PARAMETER :: ind_CH3O2_a01 = 0 
  INTEGER, PARAMETER :: ind_CH3OOH_a01 = 0 
  INTEGER, PARAMETER :: ind_CO2_a01 = 0 
  INTEGER, PARAMETER :: ind_CH3CO2H_a01 = 0 
  INTEGER, PARAMETER :: ind_PAN_a01 = 0 
  INTEGER, PARAMETER :: ind_C2H5O2_a01 = 0 
  INTEGER, PARAMETER :: ind_CH3CHO_a01 = 0 
  INTEGER, PARAMETER :: ind_CH3COCH3_a01 = 0 
  INTEGER, PARAMETER :: ind_Cl_a01 = 0 
  INTEGER, PARAMETER :: ind_Cl2_a01 = 0 
  INTEGER, PARAMETER :: ind_HCl_a01 = 0 
  INTEGER, PARAMETER :: ind_HOCl_a01 = 0 
  INTEGER, PARAMETER :: ind_Br_a01 = 0 
  INTEGER, PARAMETER :: ind_Br2_a01 = 0 
  INTEGER, PARAMETER :: ind_HBr_a01 = 0 
  INTEGER, PARAMETER :: ind_HOBr_a01 = 0 
  INTEGER, PARAMETER :: ind_BrCl_a01 = 0 
  INTEGER, PARAMETER :: ind_I2_a01 = 0 
  INTEGER, PARAMETER :: ind_IO_a01 = 0 
  INTEGER, PARAMETER :: ind_HI_a01 = 0 
  INTEGER, PARAMETER :: ind_HOI_a01 = 0 
  INTEGER, PARAMETER :: ind_ICl_a01 = 0 
  INTEGER, PARAMETER :: ind_IBr_a01 = 0 
  INTEGER, PARAMETER :: ind_HIO3_a01 = 0 
  INTEGER, PARAMETER :: ind_H2SO4_a01 = 0 
  INTEGER, PARAMETER :: ind_DMS_a01 = 0 
  INTEGER, PARAMETER :: ind_DMSO_a01 = 0 
  INTEGER, PARAMETER :: ind_Hg_a01 = 0 
  INTEGER, PARAMETER :: ind_HgO_a01 = 0 
  INTEGER, PARAMETER :: ind_HgOH_a01 = 0 
  INTEGER, PARAMETER :: ind_HgOHOH_a01 = 0 
  INTEGER, PARAMETER :: ind_HgOHCl_a01 = 0 
  INTEGER, PARAMETER :: ind_HgCl2_a01 = 0 
  INTEGER, PARAMETER :: ind_HgBr2_a01 = 0 
  INTEGER, PARAMETER :: ind_HgSO3_a01 = 0 
  INTEGER, PARAMETER :: ind_ClHgBr_a01 = 0 
  INTEGER, PARAMETER :: ind_BrHgOBr_a01 = 0 
  INTEGER, PARAMETER :: ind_ClHgOBr_a01 = 0 
  INTEGER, PARAMETER :: ind_O2m_a01 = 0 
  INTEGER, PARAMETER :: ind_OHm_a01 = 0 
  INTEGER, PARAMETER :: ind_NH4p_a01 = 0 
  INTEGER, PARAMETER :: ind_NO2m_a01 = 0 
  INTEGER, PARAMETER :: ind_NO3m_a01 = 0 
  INTEGER, PARAMETER :: ind_NO4m_a01 = 0 
  INTEGER, PARAMETER :: ind_CO3m_a01 = 0 
  INTEGER, PARAMETER :: ind_HCOOm_a01 = 0 
  INTEGER, PARAMETER :: ind_HCO3m_a01 = 0 
  INTEGER, PARAMETER :: ind_CH3COOm_a01 = 0 
  INTEGER, PARAMETER :: ind_Clm_a01 = 0 
  INTEGER, PARAMETER :: ind_Cl2m_a01 = 0 
  INTEGER, PARAMETER :: ind_ClOm_a01 = 0 
  INTEGER, PARAMETER :: ind_ClOHm_a01 = 0 
  INTEGER, PARAMETER :: ind_Brm_a01 = 0 
  INTEGER, PARAMETER :: ind_Br2m_a01 = 0 
  INTEGER, PARAMETER :: ind_BrOm_a01 = 0 
  INTEGER, PARAMETER :: ind_BrOHm_a01 = 0 
  INTEGER, PARAMETER :: ind_BrCl2m_a01 = 0 
  INTEGER, PARAMETER :: ind_Br2Clm_a01 = 0 
  INTEGER, PARAMETER :: ind_Im_a01 = 0 
  INTEGER, PARAMETER :: ind_IO2m_a01 = 0 
  INTEGER, PARAMETER :: ind_IO3m_a01 = 0 
  INTEGER, PARAMETER :: ind_ICl2m_a01 = 0 
  INTEGER, PARAMETER :: ind_IClBrm_a01 = 0 
  INTEGER, PARAMETER :: ind_IBr2m_a01 = 0 
  INTEGER, PARAMETER :: ind_SO3m_a01 = 0 
  INTEGER, PARAMETER :: ind_SO4m_a01 = 0 
  INTEGER, PARAMETER :: ind_SO5m_a01 = 0 
  INTEGER, PARAMETER :: ind_HSO4m_a01 = 0 
  INTEGER, PARAMETER :: ind_HSO5m_a01 = 0 
  INTEGER, PARAMETER :: ind_CH3SO3m_a01 = 0 
  INTEGER, PARAMETER :: ind_CH2OHSO3m_a01 = 0 
  INTEGER, PARAMETER :: ind_Hgp_a01 = 0 
  INTEGER, PARAMETER :: ind_Hgpp_a01 = 0 
  INTEGER, PARAMETER :: ind_HgOHp_a01 = 0 
  INTEGER, PARAMETER :: ind_HgClp_a01 = 0 
  INTEGER, PARAMETER :: ind_HgCl3m_a01 = 0 
  INTEGER, PARAMETER :: ind_HgCl4mm_a01 = 0 
  INTEGER, PARAMETER :: ind_HgBrp_a01 = 0 
  INTEGER, PARAMETER :: ind_HgBr3m_a01 = 0 
  INTEGER, PARAMETER :: ind_HgBr4mm_a01 = 0 
  INTEGER, PARAMETER :: ind_HgSO32mm_a01 = 0 
  INTEGER, PARAMETER :: ind_D1O_a01 = 0 
  INTEGER, PARAMETER :: ind_D2O_a01 = 0 
  INTEGER, PARAMETER :: ind_DAHp_a01 = 0 
  INTEGER, PARAMETER :: ind_DA_a01 = 0 
  INTEGER, PARAMETER :: ind_DAm_a01 = 0 
  INTEGER, PARAMETER :: ind_DGtAi_a01 = 0 
  INTEGER, PARAMETER :: ind_DGtAs_a01 = 0 
  INTEGER, PARAMETER :: ind_PROD1_a01 = 0 
  INTEGER, PARAMETER :: ind_PROD2_a01 = 0 
  INTEGER, PARAMETER :: ind_Nap_a01 = 0 

! Index declaration for fixed species in FIX
!    FIX(indf_spc) = C(ind_spc) = C(NVAR+indf_spc)

  INTEGER, PARAMETER :: indf_OH = 1 

END MODULE SUAQ_messy_mecca_kpp_Parameters

