! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! The ODE Jacobian of Chemical Model File
! 
! Generated by KPP-2.2 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : cbm5_Jacobian.f90
! Time                 : Fri Jan 29 14:37:03 2010
! Working directory    : /gpfs/projects/bsc32/bsc32771/UMO/UMO-Chem/chemistry/KPP/kpp-2.2.1.December2006/models/CBM5
! Equation file        : cbm5.kpp
! Output root filename : cbm5
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE cbm5_Jacobian

  USE cbm5_Parameters
  USE cbm5_JacobianSP

  IMPLICIT NONE

CONTAINS


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Jac_SP - the Jacobian of Variables in sparse matrix representation
!   Arguments :
!      V         - Concentrations of variable species (local)
!      F         - Concentrations of fixed species (local)
!      RCT       - Rate constants (local)
!      JVS       - sparse Jacobian of variables
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE Jac_SP ( V, F, RCT, JVS )

! V - Concentrations of variable species (local)
  REAL(kind=dp) :: V(NVAR)
! F - Concentrations of fixed species (local)
  REAL(kind=dp) :: F(NFIX)
! RCT - Rate constants (local)
  REAL(kind=dp) :: RCT(NREACT)
! JVS - sparse Jacobian of variables
  REAL(kind=dp) :: JVS(LU_NONZERO)


! Local variables
! B - Temporary array
  REAL(kind=dp) :: B(273)

! B(1) = dA(1)/dV(51)
  B(1) = RCT(1)
! B(2) = dA(2)/dV(45)
  B(2) = RCT(2)*F(3)*F(5)
! B(5) = dA(3)/dV(41)
  B(5) = RCT(3)*V(50)
! B(6) = dA(3)/dV(50)
  B(6) = RCT(3)*V(41)
! B(7) = dA(4)/dV(45)
  B(7) = RCT(4)*V(51)
! B(8) = dA(4)/dV(51)
  B(8) = RCT(4)*V(45)
! B(9) = dA(5)/dV(45)
  B(9) = RCT(5)*V(51)
! B(10) = dA(5)/dV(51)
  B(10) = RCT(5)*V(45)
! B(11) = dA(6)/dV(45)
  B(11) = RCT(6)*V(50)
! B(12) = dA(6)/dV(50)
  B(12) = RCT(6)*V(45)
! B(13) = dA(7)/dV(41)
  B(13) = RCT(7)*V(51)
! B(14) = dA(7)/dV(51)
  B(14) = RCT(7)*V(41)
! B(15) = dA(8)/dV(41)
  B(15) = RCT(8)
! B(16) = dA(9)/dV(41)
  B(16) = RCT(9)
! B(17) = dA(10)/dV(3)
  B(17) = RCT(10)*F(5)
! B(19) = dA(11)/dV(3)
  B(19) = 2.2e-10*F(1)
! B(21) = dA(12)/dV(41)
  B(21) = RCT(12)*V(48)
! B(22) = dA(12)/dV(48)
  B(22) = RCT(12)*V(41)
! B(23) = dA(13)/dV(41)
  B(23) = RCT(13)*V(43)
! B(24) = dA(13)/dV(43)
  B(24) = RCT(13)*V(41)
! B(25) = dA(14)/dV(49)
  B(25) = RCT(14)
! B(26) = dA(15)/dV(49)
  B(26) = RCT(15)
! B(27) = dA(16)/dV(49)
  B(27) = RCT(16)*V(50)
! B(28) = dA(16)/dV(50)
  B(28) = RCT(16)*V(49)
! B(29) = dA(17)/dV(49)
  B(29) = RCT(17)*V(51)
! B(30) = dA(17)/dV(51)
  B(30) = RCT(17)*V(49)
! B(31) = dA(18)/dV(49)
  B(31) = RCT(18)*V(51)
! B(32) = dA(18)/dV(51)
  B(32) = RCT(18)*V(49)
! B(33) = dA(19)/dV(8)
  B(33) = 2.5e-22*F(1)
! B(35) = dA(20)/dV(8)
  B(35) = 1.8e-39*F(1)*F(1)
! B(37) = dA(21)/dV(8)
  B(37) = RCT(21)
! B(38) = dA(22)/dV(50)
  B(38) = RCT(22)*2*V(50)*F(3)
! B(40) = dA(23)/dV(50)
  B(40) = 5e-40*V(51)*F(1)
! B(41) = dA(23)/dV(51)
  B(41) = 5e-40*V(50)*F(1)
! B(43) = dA(24)/dV(48)
  B(43) = RCT(24)*V(50)
! B(44) = dA(24)/dV(50)
  B(44) = RCT(24)*V(48)
! B(45) = dA(25)/dV(11)
  B(45) = RCT(25)
! B(46) = dA(26)/dV(11)
  B(46) = RCT(26)*V(48)
! B(47) = dA(26)/dV(48)
  B(47) = RCT(26)*V(11)
! B(48) = dA(27)/dV(11)
  B(48) = 1e-20*2*V(11)
! B(49) = dA(28)/dV(48)
  B(49) = RCT(28)*V(51)
! B(50) = dA(28)/dV(51)
  B(50) = RCT(28)*V(48)
! B(51) = dA(29)/dV(27)
  B(51) = RCT(29)*V(48)
! B(52) = dA(29)/dV(48)
  B(52) = RCT(29)*V(27)
! B(53) = dA(30)/dV(43)
  B(53) = RCT(30)*V(50)
! B(54) = dA(30)/dV(50)
  B(54) = RCT(30)*V(43)
! B(55) = dA(31)/dV(43)
  B(55) = RCT(31)*V(51)
! B(56) = dA(31)/dV(51)
  B(56) = RCT(31)*V(43)
! B(57) = dA(32)/dV(17)
  B(57) = RCT(32)
! B(58) = dA(33)/dV(17)
  B(58) = RCT(33)*V(48)
! B(59) = dA(33)/dV(48)
  B(59) = RCT(33)*V(17)
! B(60) = dA(34)/dV(43)
  B(60) = RCT(34)*2*V(43)
! B(61) = dA(35)/dV(43)
  B(61) = RCT(35)*2*V(43)*F(1)
! B(63) = dA(36)/dV(12)
  B(63) = RCT(36)
! B(64) = dA(37)/dV(12)
  B(64) = RCT(37)*V(48)
! B(65) = dA(37)/dV(48)
  B(65) = RCT(37)*V(12)
! B(66) = dA(38)/dV(3)
  B(66) = 1.1e-10*F(2)
! B(68) = dA(39)/dV(48)
  B(68) = RCT(39)*F(2)
! B(70) = dA(40)/dV(45)
  B(70) = RCT(40)*V(48)
! B(71) = dA(40)/dV(48)
  B(71) = RCT(40)*V(45)
! B(72) = dA(41)/dV(48)
  B(72) = RCT(41)*2*V(48)
! B(73) = dA(42)/dV(48)
  B(73) = RCT(42)*2*V(48)
! B(74) = dA(43)/dV(43)
  B(74) = RCT(43)*V(48)
! B(75) = dA(43)/dV(48)
  B(75) = RCT(43)*V(43)
! B(76) = dA(44)/dV(43)
  B(76) = RCT(44)*V(45)
! B(77) = dA(44)/dV(45)
  B(77) = RCT(44)*V(43)
! B(78) = dA(45)/dV(12)
  B(78) = RCT(45)*V(45)
! B(79) = dA(45)/dV(45)
  B(79) = RCT(45)*V(12)
! B(80) = dA(46)/dV(45)
  B(80) = 1e-11*V(49)
! B(81) = dA(46)/dV(49)
  B(81) = 1e-11*V(45)
! B(82) = dA(47)/dV(48)
  B(82) = 2.2e-11*V(49)
! B(83) = dA(47)/dV(49)
  B(83) = 2.2e-11*V(48)
! B(84) = dA(48)/dV(43)
  B(84) = 3.5e-12*V(49)
! B(85) = dA(48)/dV(49)
  B(85) = 3.5e-12*V(43)
! B(86) = dA(49)/dV(41)
  B(86) = 1e-17*V(49)
! B(87) = dA(49)/dV(49)
  B(87) = 1e-17*V(41)
! B(88) = dA(50)/dV(49)
  B(88) = RCT(50)*2*V(49)
! B(89) = dA(51)/dV(17)
  B(89) = RCT(51)
! B(90) = dA(52)/dV(27)
  B(90) = RCT(52)
! B(91) = dA(53)/dV(8)
  B(91) = RCT(53)
! B(92) = dA(54)/dV(42)
  B(92) = RCT(54)*V(50)
! B(93) = dA(54)/dV(50)
  B(93) = RCT(54)*V(42)
! B(94) = dA(55)/dV(36)
  B(94) = RCT(55)*V(50)
! B(95) = dA(55)/dV(50)
  B(95) = RCT(55)*V(36)
! B(96) = dA(56)/dV(42)
  B(96) = RCT(56)*V(43)
! B(97) = dA(56)/dV(43)
  B(97) = RCT(56)*V(42)
! B(98) = dA(57)/dV(36)
  B(98) = RCT(57)*V(43)
! B(99) = dA(57)/dV(43)
  B(99) = RCT(57)*V(36)
! B(100) = dA(58)/dV(42)
  B(100) = 6.8e-14*2*V(42)
! B(101) = dA(59)/dV(36)
  B(101) = 6.8e-14*2*V(36)
! B(102) = dA(60)/dV(36)
  B(102) = 6.8e-14*V(42)
! B(103) = dA(60)/dV(42)
  B(103) = 6.8e-14*V(36)
! B(104) = dA(61)/dV(40)
  B(104) = RCT(61)*V(48)
! B(105) = dA(61)/dV(48)
  B(105) = RCT(61)*V(40)
! B(106) = dA(62)/dV(40)
  B(106) = RCT(62)
! B(107) = dA(63)/dV(21)
  B(107) = RCT(63)*V(48)
! B(108) = dA(63)/dV(48)
  B(108) = RCT(63)*V(21)
! B(109) = dA(64)/dV(21)
  B(109) = RCT(64)
! B(110) = dA(65)/dV(25)
  B(110) = RCT(65)*V(48)
! B(111) = dA(65)/dV(48)
  B(111) = RCT(65)*V(25)
! B(112) = dA(66)/dV(48)
  B(112) = RCT(66)*F(4)
! B(114) = dA(67)/dV(44)
  B(114) = RCT(67)*V(50)
! B(115) = dA(67)/dV(50)
  B(115) = RCT(67)*V(44)
! B(116) = dA(68)/dV(43)
  B(116) = RCT(68)*V(44)
! B(117) = dA(68)/dV(44)
  B(117) = RCT(68)*V(43)
! B(118) = dA(69)/dV(44)
  B(118) = RCT(69)*2*V(44)
! B(119) = dA(70)/dV(24)
  B(119) = RCT(70)*V(48)
! B(120) = dA(70)/dV(48)
  B(120) = RCT(70)*V(24)
! B(121) = dA(71)/dV(24)
  B(121) = RCT(71)
! B(122) = dA(72)/dV(7)
  B(122) = RCT(72)*V(48)
! B(123) = dA(72)/dV(48)
  B(123) = RCT(72)*V(7)
! B(124) = dA(73)/dV(39)
  B(124) = 9e-12*V(48)
! B(125) = dA(73)/dV(48)
  B(125) = 9e-12*V(39)
! B(126) = dA(74)/dV(39)
  B(126) = RCT(74)
! B(127) = dA(75)/dV(39)
  B(127) = RCT(75)
! B(128) = dA(76)/dV(39)
  B(128) = RCT(76)*V(45)
! B(129) = dA(76)/dV(45)
  B(129) = RCT(76)*V(39)
! B(130) = dA(77)/dV(39)
  B(130) = 5.8e-16*V(49)
! B(131) = dA(77)/dV(49)
  B(131) = 5.8e-16*V(39)
! B(132) = dA(78)/dV(39)
  B(132) = RCT(78)*V(43)
! B(133) = dA(78)/dV(43)
  B(133) = RCT(78)*V(39)
! B(134) = dA(79)/dV(19)
  B(134) = RCT(79)
! B(135) = dA(80)/dV(19)
  B(135) = 5.6e-12*V(50)
! B(136) = dA(80)/dV(50)
  B(136) = 5.6e-12*V(19)
! B(137) = dA(81)/dV(19)
  B(137) = RCT(81)*V(43)
! B(138) = dA(81)/dV(43)
  B(138) = RCT(81)*V(19)
! B(139) = dA(82)/dV(13)
  B(139) = 4e-13*V(48)
! B(140) = dA(82)/dV(48)
  B(140) = 4e-13*V(13)
! B(141) = dA(83)/dV(38)
  B(141) = RCT(83)*V(45)
! B(142) = dA(83)/dV(45)
  B(142) = RCT(83)*V(38)
! B(143) = dA(84)/dV(38)
  B(143) = RCT(84)*V(48)
! B(144) = dA(84)/dV(48)
  B(144) = RCT(84)*V(38)
! B(145) = dA(85)/dV(38)
  B(145) = RCT(85)*V(49)
! B(146) = dA(85)/dV(49)
  B(146) = RCT(85)*V(38)
! B(147) = dA(86)/dV(38)
  B(147) = RCT(86)
! B(148) = dA(87)/dV(46)
  B(148) = RCT(87)*V(50)
! B(149) = dA(87)/dV(50)
  B(149) = RCT(87)*V(46)
! B(150) = dA(88)/dV(46)
  B(150) = RCT(88)*V(51)
! B(151) = dA(88)/dV(51)
  B(151) = RCT(88)*V(46)
! B(152) = dA(89)/dV(4)
  B(152) = RCT(89)
! B(153) = dA(90)/dV(4)
  B(153) = RCT(90)
! B(154) = dA(91)/dV(43)
  B(154) = RCT(91)*V(46)
! B(155) = dA(91)/dV(46)
  B(155) = RCT(91)*V(43)
! B(156) = dA(92)/dV(44)
  B(156) = RCT(92)*V(46)
! B(157) = dA(92)/dV(46)
  B(157) = RCT(92)*V(44)
! B(158) = dA(93)/dV(42)
  B(158) = RCT(93)*V(46)
! B(159) = dA(93)/dV(46)
  B(159) = RCT(93)*V(42)
! B(160) = dA(94)/dV(46)
  B(160) = RCT(94)*2*V(46)
! B(161) = dA(95)/dV(14)
  B(161) = RCT(95)*V(48)
! B(162) = dA(95)/dV(48)
  B(162) = RCT(95)*V(14)
! B(163) = dA(96)/dV(14)
  B(163) = RCT(96)
! B(164) = dA(97)/dV(15)
  B(164) = RCT(97)*V(48)
! B(165) = dA(97)/dV(48)
  B(165) = RCT(97)*V(15)
! B(166) = dA(98)/dV(37)
  B(166) = RCT(98)*V(45)
! B(167) = dA(98)/dV(45)
  B(167) = RCT(98)*V(37)
! B(168) = dA(99)/dV(37)
  B(168) = RCT(99)*V(48)
! B(169) = dA(99)/dV(48)
  B(169) = RCT(99)*V(37)
! B(170) = dA(100)/dV(37)
  B(170) = 6.5e-15*V(49)
! B(171) = dA(100)/dV(49)
  B(171) = 6.5e-15*V(37)
! B(172) = dA(101)/dV(37)
  B(172) = RCT(101)
! B(173) = dA(102)/dV(47)
  B(173) = RCT(102)*V(50)
! B(174) = dA(102)/dV(50)
  B(174) = RCT(102)*V(47)
! B(175) = dA(103)/dV(47)
  B(175) = RCT(103)*V(51)
! B(176) = dA(103)/dV(51)
  B(176) = RCT(103)*V(47)
! B(177) = dA(104)/dV(16)
  B(177) = RCT(104)
! B(178) = dA(105)/dV(16)
  B(178) = RCT(105)
! B(179) = dA(106)/dV(16)
  B(179) = 3e-13*V(48)
! B(180) = dA(106)/dV(48)
  B(180) = 3e-13*V(16)
! B(181) = dA(107)/dV(43)
  B(181) = RCT(107)*V(47)
! B(182) = dA(107)/dV(47)
  B(182) = RCT(107)*V(43)
! B(183) = dA(108)/dV(44)
  B(183) = RCT(108)*V(47)
! B(184) = dA(108)/dV(47)
  B(184) = RCT(108)*V(44)
! B(185) = dA(109)/dV(42)
  B(185) = RCT(109)*V(47)
! B(186) = dA(109)/dV(47)
  B(186) = RCT(109)*V(42)
! B(187) = dA(110)/dV(47)
  B(187) = RCT(110)*2*V(47)
! B(188) = dA(111)/dV(46)
  B(188) = RCT(111)*V(47)
! B(189) = dA(111)/dV(47)
  B(189) = RCT(111)*V(46)
! B(190) = dA(112)/dV(33)
  B(190) = 8.1e-13*V(48)
! B(191) = dA(112)/dV(48)
  B(191) = 8.1e-13*V(33)
! B(192) = dA(113)/dV(23)
  B(192) = RCT(113)
! B(193) = dA(114)/dV(23)
  B(193) = 1600
! B(194) = dA(115)/dV(23)
  B(194) = 1.5e-11*V(51)
! B(195) = dA(115)/dV(51)
  B(195) = 1.5e-11*V(23)
! B(196) = dA(116)/dV(30)
  B(196) = RCT(116)*V(45)
! B(197) = dA(116)/dV(45)
  B(197) = RCT(116)*V(30)
! B(198) = dA(117)/dV(30)
  B(198) = 3.2e-11*V(48)
! B(199) = dA(117)/dV(48)
  B(199) = 3.2e-11*V(30)
! B(200) = dA(118)/dV(30)
  B(200) = RCT(118)*V(41)
! B(201) = dA(118)/dV(41)
  B(201) = RCT(118)*V(30)
! B(202) = dA(119)/dV(30)
  B(202) = RCT(119)*V(49)
! B(203) = dA(119)/dV(49)
  B(203) = RCT(119)*V(30)
! B(204) = dA(120)/dV(28)
  B(204) = RCT(120)*V(45)
! B(205) = dA(120)/dV(45)
  B(205) = RCT(120)*V(28)
! B(206) = dA(121)/dV(28)
  B(206) = RCT(121)*V(48)
! B(207) = dA(121)/dV(48)
  B(207) = RCT(121)*V(28)
! B(208) = dA(122)/dV(28)
  B(208) = RCT(122)*V(41)
! B(209) = dA(122)/dV(41)
  B(209) = RCT(122)*V(28)
! B(210) = dA(123)/dV(28)
  B(210) = RCT(123)*V(49)
! B(211) = dA(123)/dV(49)
  B(211) = RCT(123)*V(28)
! B(212) = dA(124)/dV(29)
  B(212) = 2.3e-11*V(45)
! B(213) = dA(124)/dV(45)
  B(213) = 2.3e-11*V(29)
! B(214) = dA(125)/dV(29)
  B(214) = RCT(125)*V(48)
! B(215) = dA(125)/dV(48)
  B(215) = RCT(125)*V(29)
! B(216) = dA(126)/dV(29)
  B(216) = RCT(126)*V(41)
! B(217) = dA(126)/dV(41)
  B(217) = RCT(126)*V(29)
! B(218) = dA(127)/dV(29)
  B(218) = RCT(127)*V(49)
! B(219) = dA(127)/dV(49)
  B(219) = RCT(127)*V(29)
! B(220) = dA(128)/dV(5)
  B(220) = RCT(128)*V(48)
! B(221) = dA(128)/dV(48)
  B(221) = RCT(128)*V(5)
! B(222) = dA(129)/dV(18)
  B(222) = 8.1e-12*V(50)
! B(223) = dA(129)/dV(50)
  B(223) = 8.1e-12*V(18)
! B(224) = dA(130)/dV(18)
  B(224) = 4.2
! B(225) = dA(131)/dV(31)
  B(225) = 4.1e-11*V(48)
! B(226) = dA(131)/dV(48)
  B(226) = 4.1e-11*V(31)
! B(227) = dA(132)/dV(31)
  B(227) = 2.2e-11*V(49)
! B(228) = dA(132)/dV(49)
  B(228) = 2.2e-11*V(31)
! B(229) = dA(133)/dV(22)
  B(229) = 1.4e-11*V(51)
! B(230) = dA(133)/dV(51)
  B(230) = 1.4e-11*V(22)
! B(231) = dA(134)/dV(22)
  B(231) = 5.5e-12*V(43)
! B(232) = dA(134)/dV(43)
  B(232) = 5.5e-12*V(22)
! B(233) = dA(135)/dV(26)
  B(233) = RCT(135)
! B(234) = dA(136)/dV(26)
  B(234) = 3e-11*V(48)
! B(235) = dA(136)/dV(48)
  B(235) = 3e-11*V(26)
! B(236) = dA(137)/dV(26)
  B(236) = RCT(137)*V(41)
! B(237) = dA(137)/dV(41)
  B(237) = RCT(137)*V(26)
! B(238) = dA(138)/dV(10)
  B(238) = RCT(138)*V(48)
! B(239) = dA(138)/dV(48)
  B(239) = RCT(138)*V(10)
! B(240) = dA(139)/dV(20)
  B(240) = 1.7e-11*V(48)
! B(241) = dA(139)/dV(48)
  B(241) = 1.7e-11*V(20)
! B(242) = dA(140)/dV(20)
  B(242) = RCT(140)
! B(243) = dA(141)/dV(34)
  B(243) = 3.6e-11*V(45)
! B(244) = dA(141)/dV(45)
  B(244) = 3.6e-11*V(34)
! B(245) = dA(142)/dV(34)
  B(245) = RCT(142)*V(48)
! B(246) = dA(142)/dV(48)
  B(246) = RCT(142)*V(34)
! B(247) = dA(143)/dV(34)
  B(247) = RCT(143)*V(41)
! B(248) = dA(143)/dV(41)
  B(248) = RCT(143)*V(34)
! B(249) = dA(144)/dV(34)
  B(249) = RCT(144)*V(49)
! B(250) = dA(144)/dV(49)
  B(250) = RCT(144)*V(34)
! B(251) = dA(145)/dV(35)
  B(251) = 3.36e-11*V(48)
! B(252) = dA(145)/dV(48)
  B(252) = 3.36e-11*V(35)
! B(253) = dA(146)/dV(35)
  B(253) = 7.1e-18*V(41)
! B(254) = dA(146)/dV(41)
  B(254) = 7.1e-18*V(35)
! B(255) = dA(147)/dV(35)
  B(255) = 1e-15*V(49)
! B(256) = dA(147)/dV(49)
  B(256) = 1e-15*V(35)
! B(257) = dA(148)/dV(35)
  B(257) = RCT(148)
! B(258) = dA(149)/dV(32)
  B(258) = 3.6e-11*V(45)
! B(259) = dA(149)/dV(45)
  B(259) = 3.6e-11*V(32)
! B(260) = dA(150)/dV(32)
  B(260) = RCT(150)*V(48)
! B(261) = dA(150)/dV(48)
  B(261) = RCT(150)*V(32)
! B(262) = dA(151)/dV(32)
  B(262) = RCT(151)*V(41)
! B(263) = dA(151)/dV(41)
  B(263) = RCT(151)*V(32)
! B(264) = dA(152)/dV(32)
  B(264) = RCT(152)*V(49)
! B(265) = dA(152)/dV(49)
  B(265) = RCT(152)*V(32)
! B(266) = dA(153)/dV(2)
  B(266) = RCT(153)*V(48)
! B(267) = dA(153)/dV(48)
  B(267) = RCT(153)*V(2)
! B(268) = dA(154)/dV(9)
  B(268) = RCT(154)*V(48)
! B(269) = dA(154)/dV(48)
  B(269) = RCT(154)*V(9)
! B(270) = dA(155)/dV(6)
  B(270) = RCT(155)*V(48)
! B(271) = dA(155)/dV(48)
  B(271) = RCT(155)*V(6)
! B(272) = dA(156)/dV(34)
  B(272) = 1.5e-19*V(51)
! B(273) = dA(156)/dV(51)
  B(273) = 1.5e-19*V(34)

! Construct the Jacobian terms from B's
! JVS(1) = Jac_FULL(1,1)
  JVS(1) = 0
! JVS(2) = Jac_FULL(1,2)
  JVS(2) = B(266)
! JVS(3) = Jac_FULL(1,48)
  JVS(3) = B(267)
! JVS(4) = Jac_FULL(2,2)
  JVS(4) = -B(266)
! JVS(5) = Jac_FULL(2,48)
  JVS(5) = -B(267)
! JVS(6) = Jac_FULL(3,3)
  JVS(6) = -B(17)-B(19)-B(66)
! JVS(7) = Jac_FULL(3,41)
  JVS(7) = B(16)
! JVS(8) = Jac_FULL(4,4)
  JVS(8) = -B(152)-B(153)
! JVS(9) = Jac_FULL(4,46)
  JVS(9) = B(150)
! JVS(10) = Jac_FULL(4,51)
  JVS(10) = B(151)
! JVS(11) = Jac_FULL(5,5)
  JVS(11) = -B(220)
! JVS(12) = Jac_FULL(5,48)
  JVS(12) = -B(221)
! JVS(13) = Jac_FULL(6,6)
  JVS(13) = -B(270)
! JVS(14) = Jac_FULL(6,48)
  JVS(14) = -B(271)
! JVS(15) = Jac_FULL(7,7)
  JVS(15) = -B(122)
! JVS(16) = Jac_FULL(7,44)
  JVS(16) = 0.63*B(118)
! JVS(17) = Jac_FULL(7,48)
  JVS(17) = -B(123)
! JVS(18) = Jac_FULL(8,8)
  JVS(18) = -B(33)-B(35)-B(37)-B(91)
! JVS(19) = Jac_FULL(8,49)
  JVS(19) = B(31)
! JVS(20) = Jac_FULL(8,51)
  JVS(20) = B(32)
! JVS(21) = Jac_FULL(9,9)
  JVS(21) = -B(268)
! JVS(22) = Jac_FULL(9,48)
  JVS(22) = -B(269)
! JVS(23) = Jac_FULL(10,10)
  JVS(23) = -B(238)
! JVS(24) = Jac_FULL(10,48)
  JVS(24) = -B(239)
! JVS(25) = Jac_FULL(11,11)
  JVS(25) = -B(45)-B(46)-2*B(48)
! JVS(26) = Jac_FULL(11,48)
  JVS(26) = B(43)-B(47)
! JVS(27) = Jac_FULL(11,50)
  JVS(27) = 2*B(40)+B(44)
! JVS(28) = Jac_FULL(11,51)
  JVS(28) = 2*B(41)
! JVS(29) = Jac_FULL(12,12)
  JVS(29) = -B(63)-B(64)-B(78)
! JVS(30) = Jac_FULL(12,43)
  JVS(30) = B(60)+B(61)
! JVS(31) = Jac_FULL(12,45)
  JVS(31) = -B(79)
! JVS(32) = Jac_FULL(12,48)
  JVS(32) = -B(65)+B(73)
! JVS(33) = Jac_FULL(13,13)
  JVS(33) = -B(139)
! JVS(34) = Jac_FULL(13,19)
  JVS(34) = B(135)
! JVS(35) = Jac_FULL(13,28)
  JVS(35) = 0.37*B(208)
! JVS(36) = Jac_FULL(13,41)
  JVS(36) = 0.37*B(209)
! JVS(37) = Jac_FULL(13,48)
  JVS(37) = -B(140)
! JVS(38) = Jac_FULL(13,50)
  JVS(38) = B(136)
! JVS(39) = Jac_FULL(14,14)
  JVS(39) = -B(161)-B(163)
! JVS(40) = Jac_FULL(14,43)
  JVS(40) = 0.8*B(154)+0.8*B(181)
! JVS(41) = Jac_FULL(14,46)
  JVS(41) = 0.8*B(155)
! JVS(42) = Jac_FULL(14,47)
  JVS(42) = 0.8*B(182)
! JVS(43) = Jac_FULL(14,48)
  JVS(43) = -B(162)
! JVS(44) = Jac_FULL(15,15)
  JVS(44) = -B(164)
! JVS(45) = Jac_FULL(15,42)
  JVS(45) = 0.1*B(158)+0.1*B(185)
! JVS(46) = Jac_FULL(15,43)
  JVS(46) = 0.2*B(154)+0.2*B(181)
! JVS(47) = Jac_FULL(15,44)
  JVS(47) = 0.1*B(156)+0.1*B(183)
! JVS(48) = Jac_FULL(15,46)
  JVS(48) = 0.2*B(155)+0.1*B(157)+0.1*B(159)
! JVS(49) = Jac_FULL(15,47)
  JVS(49) = 0.2*B(182)+0.1*B(184)+0.1*B(186)
! JVS(50) = Jac_FULL(15,48)
  JVS(50) = -B(165)
! JVS(51) = Jac_FULL(16,16)
  JVS(51) = -B(177)-B(178)-B(179)
! JVS(52) = Jac_FULL(16,47)
  JVS(52) = B(175)
! JVS(53) = Jac_FULL(16,48)
  JVS(53) = -B(180)
! JVS(54) = Jac_FULL(16,51)
  JVS(54) = B(176)
! JVS(55) = Jac_FULL(17,17)
  JVS(55) = -B(57)-B(58)-B(89)
! JVS(56) = Jac_FULL(17,43)
  JVS(56) = B(55)
! JVS(57) = Jac_FULL(17,48)
  JVS(57) = -B(59)
! JVS(58) = Jac_FULL(17,51)
  JVS(58) = B(56)
! JVS(59) = Jac_FULL(18,5)
  JVS(59) = 0.56*B(220)
! JVS(60) = Jac_FULL(18,10)
  JVS(60) = 0.3*B(238)
! JVS(61) = Jac_FULL(18,18)
  JVS(61) = -B(222)-B(224)
! JVS(62) = Jac_FULL(18,48)
  JVS(62) = 0.56*B(221)+0.3*B(239)
! JVS(63) = Jac_FULL(18,50)
  JVS(63) = -B(223)
! JVS(64) = Jac_FULL(19,19)
  JVS(64) = -B(134)-B(135)-B(137)
! JVS(65) = Jac_FULL(19,39)
  JVS(65) = B(132)
! JVS(66) = Jac_FULL(19,43)
  JVS(66) = B(133)-B(138)
! JVS(67) = Jac_FULL(19,50)
  JVS(67) = -B(136)
! JVS(68) = Jac_FULL(20,10)
  JVS(68) = 0.8*B(238)
! JVS(69) = Jac_FULL(20,20)
  JVS(69) = -B(240)-B(242)
! JVS(70) = Jac_FULL(20,26)
  JVS(70) = 0.2*B(236)
! JVS(71) = Jac_FULL(20,35)
  JVS(71) = 0.168*B(251)+0.85*B(253)
! JVS(72) = Jac_FULL(20,41)
  JVS(72) = 0.2*B(237)+0.85*B(254)
! JVS(73) = Jac_FULL(20,48)
  JVS(73) = 0.8*B(239)-B(241)+0.168*B(252)
! JVS(74) = Jac_FULL(21,21)
  JVS(74) = -B(107)-B(109)
! JVS(75) = Jac_FULL(21,36)
  JVS(75) = B(98)
! JVS(76) = Jac_FULL(21,42)
  JVS(76) = B(96)
! JVS(77) = Jac_FULL(21,43)
  JVS(77) = B(97)+B(99)
! JVS(78) = Jac_FULL(21,48)
  JVS(78) = -B(108)
! JVS(79) = Jac_FULL(22,22)
  JVS(79) = -B(229)-B(231)
! JVS(80) = Jac_FULL(22,31)
  JVS(80) = 0.4*B(225)+B(227)
! JVS(81) = Jac_FULL(22,43)
  JVS(81) = -B(232)
! JVS(82) = Jac_FULL(22,48)
  JVS(82) = 0.4*B(226)
! JVS(83) = Jac_FULL(22,49)
  JVS(83) = B(228)
! JVS(84) = Jac_FULL(22,51)
  JVS(84) = -B(230)
! JVS(85) = Jac_FULL(23,23)
  JVS(85) = -0.98*B(192)-B(193)-B(194)
! JVS(86) = Jac_FULL(23,33)
  JVS(86) = 0.76*B(190)
! JVS(87) = Jac_FULL(23,48)
  JVS(87) = 0.76*B(191)
! JVS(88) = Jac_FULL(23,51)
  JVS(88) = -B(195)
! JVS(89) = Jac_FULL(24,19)
  JVS(89) = B(137)
! JVS(90) = Jac_FULL(24,24)
  JVS(90) = -B(119)-B(121)
! JVS(91) = Jac_FULL(24,39)
  JVS(91) = 0
! JVS(92) = Jac_FULL(24,43)
  JVS(92) = B(116)+B(138)
! JVS(93) = Jac_FULL(24,44)
  JVS(93) = B(117)
! JVS(94) = Jac_FULL(24,48)
  JVS(94) = -B(120)
! JVS(95) = Jac_FULL(24,50)
  JVS(95) = 0
! JVS(96) = Jac_FULL(25,20)
  JVS(96) = B(242)
! JVS(97) = Jac_FULL(25,25)
  JVS(97) = -B(110)
! JVS(98) = Jac_FULL(25,26)
  JVS(98) = B(233)+2*B(234)+0.69*B(236)
! JVS(99) = Jac_FULL(25,28)
  JVS(99) = B(204)+0.63*B(208)
! JVS(100) = Jac_FULL(25,29)
  JVS(100) = 0.1*B(212)+0.25*B(216)
! JVS(101) = Jac_FULL(25,30)
  JVS(101) = 0.2*B(196)+0.33*B(200)
! JVS(102) = Jac_FULL(25,32)
  JVS(102) = 0.001*B(262)
! JVS(103) = Jac_FULL(25,34)
  JVS(103) = 0.066*B(247)
! JVS(104) = Jac_FULL(25,35)
  JVS(104) = 0.334*B(251)+0.225*B(253)+0.643*B(255)+0.333*B(257)
! JVS(105) = Jac_FULL(25,37)
  JVS(105) = B(172)
! JVS(106) = Jac_FULL(25,38)
  JVS(106) = B(147)
! JVS(107) = Jac_FULL(25,39)
  JVS(107) = B(124)+B(126)+B(127)+B(128)+B(130)
! JVS(108) = Jac_FULL(25,41)
  JVS(108) = 0.33*B(201)+0.63*B(209)+0.25*B(217)+0.69*B(237)+0.066*B(248)+0.225*B(254)+0.001*B(263)
! JVS(109) = Jac_FULL(25,45)
  JVS(109) = B(129)+0.2*B(197)+B(205)+0.1*B(213)
! JVS(110) = Jac_FULL(25,48)
  JVS(110) = -B(111)+B(125)+2*B(235)+0.334*B(252)
! JVS(111) = Jac_FULL(25,49)
  JVS(111) = B(131)+0.643*B(256)
! JVS(112) = Jac_FULL(26,18)
  JVS(112) = 0.9*B(222)
! JVS(113) = Jac_FULL(26,26)
  JVS(113) = -B(233)-B(234)-B(236)
! JVS(114) = Jac_FULL(26,31)
  JVS(114) = 0.3*B(225)
! JVS(115) = Jac_FULL(26,41)
  JVS(115) = -B(237)
! JVS(116) = Jac_FULL(26,48)
  JVS(116) = 0.3*B(226)-B(235)
! JVS(117) = Jac_FULL(26,50)
  JVS(117) = 0.9*B(223)
! JVS(118) = Jac_FULL(27,8)
  JVS(118) = 2*B(33)+2*B(35)
! JVS(119) = Jac_FULL(27,27)
  JVS(119) = -B(51)-B(90)
! JVS(120) = Jac_FULL(27,31)
  JVS(120) = B(227)
! JVS(121) = Jac_FULL(27,35)
  JVS(121) = 0.15*B(255)
! JVS(122) = Jac_FULL(27,37)
  JVS(122) = B(170)
! JVS(123) = Jac_FULL(27,38)
  JVS(123) = B(145)
! JVS(124) = Jac_FULL(27,39)
  JVS(124) = B(130)
! JVS(125) = Jac_FULL(27,40)
  JVS(125) = B(104)
! JVS(126) = Jac_FULL(27,43)
  JVS(126) = B(84)
! JVS(127) = Jac_FULL(27,48)
  JVS(127) = B(49)-B(52)+B(105)
! JVS(128) = Jac_FULL(27,49)
  JVS(128) = B(85)+B(131)+B(146)+B(171)+B(228)+0.15*B(256)
! JVS(129) = Jac_FULL(27,51)
  JVS(129) = B(50)
! JVS(130) = Jac_FULL(28,28)
  JVS(130) = -B(204)-B(206)-B(208)-B(210)
! JVS(131) = Jac_FULL(28,41)
  JVS(131) = -B(209)
! JVS(132) = Jac_FULL(28,45)
  JVS(132) = -B(205)
! JVS(133) = Jac_FULL(28,48)
  JVS(133) = -B(207)
! JVS(134) = Jac_FULL(28,49)
  JVS(134) = -B(211)
! JVS(135) = Jac_FULL(29,29)
  JVS(135) = -B(212)-B(214)-B(216)-B(218)
! JVS(136) = Jac_FULL(29,41)
  JVS(136) = -B(217)
! JVS(137) = Jac_FULL(29,45)
  JVS(137) = -B(213)
! JVS(138) = Jac_FULL(29,48)
  JVS(138) = -B(215)
! JVS(139) = Jac_FULL(29,49)
  JVS(139) = -B(219)
! JVS(140) = Jac_FULL(30,30)
  JVS(140) = -B(196)-B(198)-B(200)-B(202)
! JVS(141) = Jac_FULL(30,41)
  JVS(141) = -B(201)
! JVS(142) = Jac_FULL(30,45)
  JVS(142) = -B(197)
! JVS(143) = Jac_FULL(30,48)
  JVS(143) = -B(199)
! JVS(144) = Jac_FULL(30,49)
  JVS(144) = -B(203)
! JVS(145) = Jac_FULL(31,5)
  JVS(145) = 0.36*B(220)
! JVS(146) = Jac_FULL(31,10)
  JVS(146) = 0.2*B(238)
! JVS(147) = Jac_FULL(31,18)
  JVS(147) = B(224)
! JVS(148) = Jac_FULL(31,22)
  JVS(148) = B(231)
! JVS(149) = Jac_FULL(31,31)
  JVS(149) = -B(225)-B(227)
! JVS(150) = Jac_FULL(31,43)
  JVS(150) = B(232)
! JVS(151) = Jac_FULL(31,48)
  JVS(151) = 0.36*B(221)-B(226)+0.2*B(239)
! JVS(152) = Jac_FULL(31,49)
  JVS(152) = -B(228)
! JVS(153) = Jac_FULL(31,50)
  JVS(153) = 0
! JVS(154) = Jac_FULL(31,51)
  JVS(154) = 0
! JVS(155) = Jac_FULL(32,32)
  JVS(155) = -B(258)-B(260)-B(262)-B(264)
! JVS(156) = Jac_FULL(32,41)
  JVS(156) = -B(263)
! JVS(157) = Jac_FULL(32,45)
  JVS(157) = -B(259)
! JVS(158) = Jac_FULL(32,48)
  JVS(158) = -B(261)
! JVS(159) = Jac_FULL(32,49)
  JVS(159) = -B(265)
! JVS(160) = Jac_FULL(33,10)
  JVS(160) = 1.1*B(238)
! JVS(161) = Jac_FULL(33,23)
  JVS(161) = -2.1*B(192)
! JVS(162) = Jac_FULL(33,29)
  JVS(162) = 0.1*B(212)
! JVS(163) = Jac_FULL(33,30)
  JVS(163) = 0.2*B(196)-0.7*B(198)-B(200)-B(202)
! JVS(164) = Jac_FULL(33,32)
  JVS(164) = 5.12*B(258)+1.66*B(260)+7*B(262)
! JVS(165) = Jac_FULL(33,33)
  JVS(165) = -1.11*B(190)
! JVS(166) = Jac_FULL(33,34)
  JVS(166) = 0.25*B(243)+0.35*B(247)+2.4*B(249)+2.4*B(272)
! JVS(167) = Jac_FULL(33,35)
  JVS(167) = 1.565*B(251)+0.36*B(253)+1.282*B(255)+0.832*B(257)
! JVS(168) = Jac_FULL(33,40)
  JVS(168) = -0.66*B(104)-0.66*B(106)
! JVS(169) = Jac_FULL(33,41)
  JVS(169) = -B(201)+0.35*B(248)+0.36*B(254)+7*B(263)
! JVS(170) = Jac_FULL(33,45)
  JVS(170) = 0.2*B(197)+0.1*B(213)+0.25*B(244)+5.12*B(259)
! JVS(171) = Jac_FULL(33,48)
  JVS(171) = -0.66*B(105)-1.11*B(191)-0.7*B(199)+1.1*B(239)+1.565*B(252)+1.66*B(261)
! JVS(172) = Jac_FULL(33,49)
  JVS(172) = -B(203)+2.4*B(250)+1.282*B(256)
! JVS(173) = Jac_FULL(33,51)
  JVS(173) = 2.4*B(273)
! JVS(174) = Jac_FULL(34,34)
  JVS(174) = -B(243)-B(245)-B(247)-B(249)-B(272)
! JVS(175) = Jac_FULL(34,41)
  JVS(175) = -B(248)
! JVS(176) = Jac_FULL(34,45)
  JVS(176) = -B(244)
! JVS(177) = Jac_FULL(34,48)
  JVS(177) = -B(246)
! JVS(178) = Jac_FULL(34,49)
  JVS(178) = -B(250)
! JVS(179) = Jac_FULL(34,51)
  JVS(179) = -B(273)
! JVS(180) = Jac_FULL(35,34)
  JVS(180) = 0.75*B(243)+0.912*B(245)+0.65*B(247)+0.2*B(249)+0.2*B(272)
! JVS(181) = Jac_FULL(35,35)
  JVS(181) = -B(251)-B(253)-B(255)-B(257)
! JVS(182) = Jac_FULL(35,41)
  JVS(182) = 0.65*B(248)-B(254)
! JVS(183) = Jac_FULL(35,45)
  JVS(183) = 0.75*B(244)
! JVS(184) = Jac_FULL(35,48)
  JVS(184) = 0.912*B(246)-B(252)
! JVS(185) = Jac_FULL(35,49)
  JVS(185) = 0.2*B(250)-B(256)
! JVS(186) = Jac_FULL(35,51)
  JVS(186) = 0.2*B(273)
! JVS(187) = Jac_FULL(36,6)
  JVS(187) = 0.009*B(270)
! JVS(188) = Jac_FULL(36,23)
  JVS(188) = 0.04*B(192)
! JVS(189) = Jac_FULL(36,30)
  JVS(189) = 0.01*B(196)+0.09*B(202)
! JVS(190) = Jac_FULL(36,32)
  JVS(190) = 0.25*B(260)+0.18*B(262)+0.25*B(264)
! JVS(191) = Jac_FULL(36,33)
  JVS(191) = 0.13*B(190)
! JVS(192) = Jac_FULL(36,34)
  JVS(192) = 0.088*B(245)
! JVS(193) = Jac_FULL(36,35)
  JVS(193) = 0
! JVS(194) = Jac_FULL(36,36)
  JVS(194) = -B(94)-B(98)-2*B(101)-B(102)
! JVS(195) = Jac_FULL(36,40)
  JVS(195) = 0
! JVS(196) = Jac_FULL(36,41)
  JVS(196) = 0.18*B(263)
! JVS(197) = Jac_FULL(36,42)
  JVS(197) = -B(103)
! JVS(198) = Jac_FULL(36,43)
  JVS(198) = -B(99)
! JVS(199) = Jac_FULL(36,45)
  JVS(199) = 0.01*B(197)
! JVS(200) = Jac_FULL(36,48)
  JVS(200) = 0.13*B(191)+0.088*B(246)+0.25*B(261)+0.009*B(271)
! JVS(201) = Jac_FULL(36,49)
  JVS(201) = 0.09*B(203)+0.25*B(265)
! JVS(202) = Jac_FULL(36,50)
  JVS(202) = -B(95)
! JVS(203) = Jac_FULL(36,51)
  JVS(203) = 0
! JVS(204) = Jac_FULL(37,9)
  JVS(204) = 0.05*B(268)
! JVS(205) = Jac_FULL(37,21)
  JVS(205) = 0.5*B(107)+0.5*B(109)
! JVS(206) = Jac_FULL(37,23)
  JVS(206) = 0.5*B(192)
! JVS(207) = Jac_FULL(37,26)
  JVS(207) = 0.03*B(236)
! JVS(208) = Jac_FULL(37,28)
  JVS(208) = 0.22*B(206)
! JVS(209) = Jac_FULL(37,29)
  JVS(209) = 0.66*B(212)+0.7*B(214)+0.35*B(216)+0.64*B(218)
! JVS(210) = Jac_FULL(37,30)
  JVS(210) = 0.3*B(196)+0.62*B(198)+0.32*B(200)+0.56*B(202)
! JVS(211) = Jac_FULL(37,31)
  JVS(211) = 0
! JVS(212) = Jac_FULL(37,32)
  JVS(212) = 0.15*B(258)+0.47*B(260)+0.21*B(262)+0.47*B(264)
! JVS(213) = Jac_FULL(37,33)
  JVS(213) = 0.05*B(190)
! JVS(214) = Jac_FULL(37,34)
  JVS(214) = 0.15*B(247)+0.8*B(249)+0.8*B(272)
! JVS(215) = Jac_FULL(37,35)
  JVS(215) = 0.12*B(251)+0.375*B(255)
! JVS(216) = Jac_FULL(37,36)
  JVS(216) = 0
! JVS(217) = Jac_FULL(37,37)
  JVS(217) = -B(166)-B(168)-B(170)-B(172)
! JVS(218) = Jac_FULL(37,40)
  JVS(218) = 0.33*B(104)+0.33*B(106)
! JVS(219) = Jac_FULL(37,41)
  JVS(219) = 0.32*B(201)+0.35*B(217)+0.03*B(237)+0.15*B(248)+0.21*B(263)
! JVS(220) = Jac_FULL(37,42)
  JVS(220) = 0
! JVS(221) = Jac_FULL(37,43)
  JVS(221) = 0
! JVS(222) = Jac_FULL(37,45)
  JVS(222) = -B(167)+0.3*B(197)+0.66*B(213)+0.15*B(259)
! JVS(223) = Jac_FULL(37,48)
  JVS(223) = 0.33*B(105)+0.5*B(108)-B(169)+0.05*B(191)+0.62*B(199)+0.22*B(207)+0.7*B(215)+0.12*B(252)+0.47*B(261)+0.05&
               &*B(269)
! JVS(224) = Jac_FULL(37,49)
  JVS(224) = -B(171)+0.56*B(203)+0.64*B(219)+0.8*B(250)+0.375*B(256)+0.47*B(265)
! JVS(225) = Jac_FULL(37,50)
  JVS(225) = 0
! JVS(226) = Jac_FULL(37,51)
  JVS(226) = 0.8*B(273)
! JVS(227) = Jac_FULL(38,6)
  JVS(227) = 0.991*B(270)
! JVS(228) = Jac_FULL(38,9)
  JVS(228) = 0.9*B(268)
! JVS(229) = Jac_FULL(38,16)
  JVS(229) = B(179)
! JVS(230) = Jac_FULL(38,21)
  JVS(230) = 0.5*B(107)+0.5*B(109)
! JVS(231) = Jac_FULL(38,23)
  JVS(231) = 0.6*B(192)
! JVS(232) = Jac_FULL(38,29)
  JVS(232) = 1.24*B(212)+1.3*B(214)+0.65*B(216)+1.18*B(218)
! JVS(233) = Jac_FULL(38,30)
  JVS(233) = 0.2*B(196)+0.33*B(198)+0.18*B(200)+0.35*B(202)
! JVS(234) = Jac_FULL(38,33)
  JVS(234) = 0.06*B(190)
! JVS(235) = Jac_FULL(38,34)
  JVS(235) = 0
! JVS(236) = Jac_FULL(38,35)
  JVS(236) = 0.252*B(251)+0.02*B(253)+0.067*B(257)
! JVS(237) = Jac_FULL(38,36)
  JVS(237) = 0
! JVS(238) = Jac_FULL(38,38)
  JVS(238) = -B(141)-B(143)-B(145)-B(147)
! JVS(239) = Jac_FULL(38,40)
  JVS(239) = 0.33*B(104)+0.33*B(106)
! JVS(240) = Jac_FULL(38,41)
  JVS(240) = 0.18*B(201)+0.65*B(217)+0.02*B(254)
! JVS(241) = Jac_FULL(38,42)
  JVS(241) = 0.9*B(185)
! JVS(242) = Jac_FULL(38,43)
  JVS(242) = 0
! JVS(243) = Jac_FULL(38,44)
  JVS(243) = 0.9*B(183)
! JVS(244) = Jac_FULL(38,45)
  JVS(244) = -B(142)+0.2*B(197)+1.24*B(213)
! JVS(245) = Jac_FULL(38,46)
  JVS(245) = B(188)
! JVS(246) = Jac_FULL(38,47)
  JVS(246) = B(173)+0.9*B(184)+0.9*B(186)+2*B(187)+B(189)
! JVS(247) = Jac_FULL(38,48)
  JVS(247) = 0.33*B(105)+0.5*B(108)-B(144)+B(180)+0.06*B(191)+0.33*B(199)+1.3*B(215)+0.252*B(252)+0.9*B(269)+0.991&
               &*B(271)
! JVS(248) = Jac_FULL(38,49)
  JVS(248) = -B(146)+0.35*B(203)+1.18*B(219)
! JVS(249) = Jac_FULL(38,50)
  JVS(249) = B(174)
! JVS(250) = Jac_FULL(38,51)
  JVS(250) = 0
! JVS(251) = Jac_FULL(39,7)
  JVS(251) = B(122)
! JVS(252) = Jac_FULL(39,9)
  JVS(252) = 0.1*B(268)
! JVS(253) = Jac_FULL(39,19)
  JVS(253) = B(134)
! JVS(254) = Jac_FULL(39,24)
  JVS(254) = B(121)
! JVS(255) = Jac_FULL(39,26)
  JVS(255) = B(234)+0.7*B(236)
! JVS(256) = Jac_FULL(39,28)
  JVS(256) = B(204)+1.56*B(206)+B(208)+2*B(210)
! JVS(257) = Jac_FULL(39,29)
  JVS(257) = 0.25*B(216)
! JVS(258) = Jac_FULL(39,30)
  JVS(258) = 0.2*B(196)+0.8*B(198)+0.74*B(200)+B(202)
! JVS(259) = Jac_FULL(39,31)
  JVS(259) = 0
! JVS(260) = Jac_FULL(39,32)
  JVS(260) = 0.28*B(260)+0.24*B(262)
! JVS(261) = Jac_FULL(39,34)
  JVS(261) = 0.5*B(243)+0.629*B(245)+0.6*B(247)
! JVS(262) = Jac_FULL(39,35)
  JVS(262) = 0.167*B(251)+0.15*B(253)+0.282*B(255)+0.9*B(257)
! JVS(263) = Jac_FULL(39,39)
  JVS(263) = -B(124)-B(126)-B(127)-B(128)-B(130)-B(132)
! JVS(264) = Jac_FULL(39,40)
  JVS(264) = 0.33*B(104)+0.33*B(106)
! JVS(265) = Jac_FULL(39,41)
  JVS(265) = 0.74*B(201)+B(209)+0.25*B(217)+0.7*B(237)+0.6*B(248)+0.15*B(254)+0.24*B(263)
! JVS(266) = Jac_FULL(39,43)
  JVS(266) = -B(133)
! JVS(267) = Jac_FULL(39,44)
  JVS(267) = B(114)+1.37*B(118)+B(156)+0.1*B(183)
! JVS(268) = Jac_FULL(39,45)
  JVS(268) = -B(129)+0.2*B(197)+B(205)+0.5*B(244)
! JVS(269) = Jac_FULL(39,46)
  JVS(269) = B(157)
! JVS(270) = Jac_FULL(39,47)
  JVS(270) = 0.1*B(184)
! JVS(271) = Jac_FULL(39,48)
  JVS(271) = 0.33*B(105)+B(123)-B(125)+0.8*B(199)+1.56*B(207)+B(235)+0.629*B(246)+0.167*B(252)+0.28*B(261)+0.1*B(269)
! JVS(272) = Jac_FULL(39,49)
  JVS(272) = -B(131)+B(203)+2*B(211)+0.282*B(256)
! JVS(273) = Jac_FULL(39,50)
  JVS(273) = B(115)
! JVS(274) = Jac_FULL(39,51)
  JVS(274) = 0
! JVS(275) = Jac_FULL(40,18)
  JVS(275) = 0.1*B(222)
! JVS(276) = Jac_FULL(40,22)
  JVS(276) = B(229)
! JVS(277) = Jac_FULL(40,23)
  JVS(277) = B(194)
! JVS(278) = Jac_FULL(40,31)
  JVS(278) = 0
! JVS(279) = Jac_FULL(40,32)
  JVS(279) = 0.53*B(264)
! JVS(280) = Jac_FULL(40,33)
  JVS(280) = 0
! JVS(281) = Jac_FULL(40,34)
  JVS(281) = 0.8*B(249)+0.8*B(272)
! JVS(282) = Jac_FULL(40,35)
  JVS(282) = 0.85*B(255)
! JVS(283) = Jac_FULL(40,36)
  JVS(283) = B(94)
! JVS(284) = Jac_FULL(40,40)
  JVS(284) = -B(104)-B(106)
! JVS(285) = Jac_FULL(40,41)
  JVS(285) = 0
! JVS(286) = Jac_FULL(40,42)
  JVS(286) = 0
! JVS(287) = Jac_FULL(40,43)
  JVS(287) = 0
! JVS(288) = Jac_FULL(40,45)
  JVS(288) = 0
! JVS(289) = Jac_FULL(40,48)
  JVS(289) = -B(105)
! JVS(290) = Jac_FULL(40,49)
  JVS(290) = 0.8*B(250)+0.85*B(256)+0.53*B(265)
! JVS(291) = Jac_FULL(40,50)
  JVS(291) = B(95)+0.1*B(223)
! JVS(292) = Jac_FULL(40,51)
  JVS(292) = B(195)+B(230)+0.8*B(273)
! JVS(293) = Jac_FULL(41,26)
  JVS(293) = -B(236)
! JVS(294) = Jac_FULL(41,28)
  JVS(294) = -B(208)
! JVS(295) = Jac_FULL(41,29)
  JVS(295) = -B(216)
! JVS(296) = Jac_FULL(41,30)
  JVS(296) = -B(200)
! JVS(297) = Jac_FULL(41,31)
  JVS(297) = 0
! JVS(298) = Jac_FULL(41,32)
  JVS(298) = -B(262)
! JVS(299) = Jac_FULL(41,34)
  JVS(299) = -B(247)
! JVS(300) = Jac_FULL(41,35)
  JVS(300) = -B(253)
! JVS(301) = Jac_FULL(41,41)
  JVS(301) = -B(5)-B(13)-B(15)-B(16)-B(21)-B(23)-B(86)-B(201)-B(209)-B(217)-B(237)-B(248)-B(254)-B(263)
! JVS(302) = Jac_FULL(41,43)
  JVS(302) = -B(24)+0.2*B(154)+0.2*B(181)
! JVS(303) = Jac_FULL(41,45)
  JVS(303) = B(2)
! JVS(304) = Jac_FULL(41,46)
  JVS(304) = 0.2*B(155)
! JVS(305) = Jac_FULL(41,47)
  JVS(305) = 0.2*B(182)
! JVS(306) = Jac_FULL(41,48)
  JVS(306) = -B(22)
! JVS(307) = Jac_FULL(41,49)
  JVS(307) = -B(87)
! JVS(308) = Jac_FULL(41,50)
  JVS(308) = -B(6)
! JVS(309) = Jac_FULL(41,51)
  JVS(309) = -B(14)
! JVS(310) = Jac_FULL(42,5)
  JVS(310) = 0.08*B(220)
! JVS(311) = Jac_FULL(42,6)
  JVS(311) = 0.991*B(270)
! JVS(312) = Jac_FULL(42,9)
  JVS(312) = 0.1*B(268)
! JVS(313) = Jac_FULL(42,10)
  JVS(313) = 0.5*B(238)
! JVS(314) = Jac_FULL(42,20)
  JVS(314) = B(240)
! JVS(315) = Jac_FULL(42,21)
  JVS(315) = B(107)
! JVS(316) = Jac_FULL(42,23)
  JVS(316) = 0.96*B(192)
! JVS(317) = Jac_FULL(42,24)
  JVS(317) = 0.3*B(119)
! JVS(318) = Jac_FULL(42,26)
  JVS(318) = B(234)+0.03*B(236)
! JVS(319) = Jac_FULL(42,28)
  JVS(319) = 0.7*B(204)+B(206)+B(210)
! JVS(320) = Jac_FULL(42,29)
  JVS(320) = 0.1*B(212)+B(214)
! JVS(321) = Jac_FULL(42,30)
  JVS(321) = 0.2*B(196)+0.8*B(198)+0.22*B(200)+0.91*B(202)
! JVS(322) = Jac_FULL(42,31)
  JVS(322) = 0.6*B(225)
! JVS(323) = Jac_FULL(42,32)
  JVS(323) = 1.25*B(260)+0.76*B(262)+1.03*B(264)
! JVS(324) = Jac_FULL(42,33)
  JVS(324) = 0.87*B(190)
! JVS(325) = Jac_FULL(42,34)
  JVS(325) = 0.25*B(243)+0.991*B(245)+0.2*B(247)+B(249)+B(272)
! JVS(326) = Jac_FULL(42,35)
  JVS(326) = 0.713*B(251)+0.064*B(253)+0.075*B(255)+0.7*B(257)
! JVS(327) = Jac_FULL(42,36)
  JVS(327) = -B(102)
! JVS(328) = Jac_FULL(42,39)
  JVS(328) = 0
! JVS(329) = Jac_FULL(42,40)
  JVS(329) = 0
! JVS(330) = Jac_FULL(42,41)
  JVS(330) = 0.22*B(201)+0.03*B(237)+0.2*B(248)+0.064*B(254)+0.76*B(263)
! JVS(331) = Jac_FULL(42,42)
  JVS(331) = -B(92)-B(96)-2*B(100)-B(103)-B(158)-B(185)
! JVS(332) = Jac_FULL(42,43)
  JVS(332) = -B(97)
! JVS(333) = Jac_FULL(42,44)
  JVS(333) = 0.9*B(183)
! JVS(334) = Jac_FULL(42,45)
  JVS(334) = 0.2*B(197)+0.7*B(205)+0.1*B(213)+0.25*B(244)
! JVS(335) = Jac_FULL(42,46)
  JVS(335) = -B(159)+B(188)
! JVS(336) = Jac_FULL(42,47)
  JVS(336) = B(173)+0.9*B(184)-B(186)+2*B(187)+B(189)
! JVS(337) = Jac_FULL(42,48)
  JVS(337) = B(108)+0.3*B(120)+0.87*B(191)+0.8*B(199)+B(207)+B(215)+0.08*B(221)+0.6*B(226)+B(235)+0.5*B(239)+B(241)&
               &+0.991*B(246)+0.713*B(252)+1.25*B(261)+0.1*B(269)+0.991*B(271)
! JVS(338) = Jac_FULL(42,49)
  JVS(338) = 0.91*B(203)+B(211)+B(250)+0.075*B(256)+1.03*B(265)
! JVS(339) = Jac_FULL(42,50)
  JVS(339) = -B(93)+B(174)
! JVS(340) = Jac_FULL(42,51)
  JVS(340) = B(273)
! JVS(341) = Jac_FULL(43,2)
  JVS(341) = B(266)
! JVS(342) = Jac_FULL(43,3)
  JVS(342) = B(66)
! JVS(343) = Jac_FULL(43,5)
  JVS(343) = 0.44*B(220)
! JVS(344) = Jac_FULL(43,6)
  JVS(344) = B(270)
! JVS(345) = Jac_FULL(43,7)
  JVS(345) = B(122)
! JVS(346) = Jac_FULL(43,9)
  JVS(346) = B(268)
! JVS(347) = Jac_FULL(43,10)
  JVS(347) = 0.7*B(238)
! JVS(348) = Jac_FULL(43,12)
  JVS(348) = B(64)+B(78)
! JVS(349) = Jac_FULL(43,13)
  JVS(349) = B(139)
! JVS(350) = Jac_FULL(43,17)
  JVS(350) = B(57)+0.61*B(89)
! JVS(351) = Jac_FULL(43,18)
  JVS(351) = 0.9*B(222)+B(224)
! JVS(352) = Jac_FULL(43,19)
  JVS(352) = B(134)+B(135)-B(137)
! JVS(353) = Jac_FULL(43,20)
  JVS(353) = B(242)
! JVS(354) = Jac_FULL(43,21)
  JVS(354) = B(109)
! JVS(355) = Jac_FULL(43,22)
  JVS(355) = -B(231)
! JVS(356) = Jac_FULL(43,23)
  JVS(356) = 0.94*B(192)+B(193)
! JVS(357) = Jac_FULL(43,24)
  JVS(357) = 0.3*B(119)+B(121)
! JVS(358) = Jac_FULL(43,25)
  JVS(358) = B(110)
! JVS(359) = Jac_FULL(43,26)
  JVS(359) = B(233)+2*B(234)+0.76*B(236)
! JVS(360) = Jac_FULL(43,28)
  JVS(360) = 1.7*B(204)+B(206)+0.13*B(208)
! JVS(361) = Jac_FULL(43,29)
  JVS(361) = 0.1*B(212)+B(214)+0.5*B(216)+B(218)
! JVS(362) = Jac_FULL(43,30)
  JVS(362) = 0.3*B(196)+0.95*B(198)+0.44*B(200)
! JVS(363) = Jac_FULL(43,31)
  JVS(363) = 0.6*B(225)
! JVS(364) = Jac_FULL(43,32)
  JVS(364) = 0.75*B(260)+0.07*B(262)+0.28*B(264)
! JVS(365) = Jac_FULL(43,33)
  JVS(365) = 0.11*B(190)
! JVS(366) = Jac_FULL(43,34)
  JVS(366) = 0.25*B(243)+0.912*B(245)+0.066*B(247)+0.8*B(249)+0.8*B(272)
! JVS(367) = Jac_FULL(43,35)
  JVS(367) = 0.503*B(251)+0.154*B(253)+0.925*B(255)+1.033*B(257)
! JVS(368) = Jac_FULL(43,36)
  JVS(368) = -B(98)
! JVS(369) = Jac_FULL(43,37)
  JVS(369) = B(172)
! JVS(370) = Jac_FULL(43,38)
  JVS(370) = B(147)
! JVS(371) = Jac_FULL(43,39)
  JVS(371) = B(124)+2*B(126)+B(128)+B(130)-B(132)
! JVS(372) = Jac_FULL(43,40)
  JVS(372) = B(104)+B(106)
! JVS(373) = Jac_FULL(43,41)
  JVS(373) = B(21)-B(23)+0.44*B(201)+0.13*B(209)+0.5*B(217)+0.76*B(237)+0.066*B(248)+0.154*B(254)+0.07*B(263)
! JVS(374) = Jac_FULL(43,42)
  JVS(374) = -B(96)
! JVS(375) = Jac_FULL(43,43)
  JVS(375) = -B(24)-B(53)-B(55)-2*B(60)-2*B(61)-B(74)-B(76)-B(84)-B(97)-B(99)-B(116)-B(133)-B(138)-B(154)-B(181)-B(232)
! JVS(376) = Jac_FULL(43,44)
  JVS(376) = B(114)-B(117)+0.74*B(118)+0.9*B(156)+B(183)
! JVS(377) = Jac_FULL(43,45)
  JVS(377) = B(70)-B(77)+B(79)+B(129)+0.3*B(197)+1.7*B(205)+0.1*B(213)+0.25*B(244)
! JVS(378) = Jac_FULL(43,46)
  JVS(378) = -B(155)+0.9*B(157)+B(188)
! JVS(379) = Jac_FULL(43,47)
  JVS(379) = B(173)-B(182)+B(184)+2*B(187)+B(189)
! JVS(380) = Jac_FULL(43,48)
  JVS(380) = B(22)+B(65)+B(68)+B(71)-B(75)+B(82)+B(105)+B(111)+0.3*B(120)+B(123)+B(125)+B(140)+0.11*B(191)+0.95*B(199)&
               &+B(207)+B(215)+0.44*B(221)+0.6*B(226)+2*B(235)+0.7*B(239)+0.912*B(246)+0.503*B(252)+0.75*B(261)+B(267)&
               &+B(269)+B(271)
! JVS(381) = Jac_FULL(43,49)
  JVS(381) = B(83)-B(85)+B(131)+B(219)+0.8*B(250)+0.925*B(256)+0.28*B(265)
! JVS(382) = Jac_FULL(43,50)
  JVS(382) = -B(54)+B(115)+B(136)+B(174)+0.9*B(223)
! JVS(383) = Jac_FULL(43,51)
  JVS(383) = -B(56)+0.8*B(273)
! JVS(384) = Jac_FULL(44,14)
  JVS(384) = B(163)
! JVS(385) = Jac_FULL(44,15)
  JVS(385) = B(164)
! JVS(386) = Jac_FULL(44,24)
  JVS(386) = 0.7*B(119)
! JVS(387) = Jac_FULL(44,37)
  JVS(387) = B(172)
! JVS(388) = Jac_FULL(44,38)
  JVS(388) = B(147)
! JVS(389) = Jac_FULL(44,39)
  JVS(389) = 0
! JVS(390) = Jac_FULL(44,40)
  JVS(390) = 0
! JVS(391) = Jac_FULL(44,41)
  JVS(391) = 0
! JVS(392) = Jac_FULL(44,42)
  JVS(392) = 0.9*B(158)
! JVS(393) = Jac_FULL(44,43)
  JVS(393) = -B(116)
! JVS(394) = Jac_FULL(44,44)
  JVS(394) = -B(114)-B(117)-2*B(118)-0.1*B(156)-B(183)
! JVS(395) = Jac_FULL(44,45)
  JVS(395) = 0
! JVS(396) = Jac_FULL(44,46)
  JVS(396) = B(148)-0.1*B(157)+0.9*B(159)+2*B(160)+B(188)
! JVS(397) = Jac_FULL(44,47)
  JVS(397) = -B(184)+B(189)
! JVS(398) = Jac_FULL(44,48)
  JVS(398) = B(112)+0.7*B(120)+B(165)
! JVS(399) = Jac_FULL(44,49)
  JVS(399) = 0
! JVS(400) = Jac_FULL(44,50)
  JVS(400) = -B(115)+B(149)
! JVS(401) = Jac_FULL(44,51)
  JVS(401) = 0
! JVS(402) = Jac_FULL(45,3)
  JVS(402) = B(17)
! JVS(403) = Jac_FULL(45,12)
  JVS(403) = -B(78)
! JVS(404) = Jac_FULL(45,28)
  JVS(404) = -B(204)
! JVS(405) = Jac_FULL(45,29)
  JVS(405) = -B(212)+0.5*B(216)
! JVS(406) = Jac_FULL(45,30)
  JVS(406) = -B(196)
! JVS(407) = Jac_FULL(45,32)
  JVS(407) = -B(258)
! JVS(408) = Jac_FULL(45,34)
  JVS(408) = -B(243)
! JVS(409) = Jac_FULL(45,37)
  JVS(409) = -B(166)
! JVS(410) = Jac_FULL(45,38)
  JVS(410) = -B(141)
! JVS(411) = Jac_FULL(45,39)
  JVS(411) = -B(128)
! JVS(412) = Jac_FULL(45,40)
  JVS(412) = 0
! JVS(413) = Jac_FULL(45,41)
  JVS(413) = B(15)+0.5*B(217)
! JVS(414) = Jac_FULL(45,42)
  JVS(414) = 0
! JVS(415) = Jac_FULL(45,43)
  JVS(415) = -B(76)
! JVS(416) = Jac_FULL(45,44)
  JVS(416) = 0
! JVS(417) = Jac_FULL(45,45)
  JVS(417) = -B(2)-B(7)-B(9)-B(11)-B(70)-B(77)-B(79)-B(80)-B(129)-B(142)-B(167)-B(197)-B(205)-B(213)-B(244)-B(259)
! JVS(418) = Jac_FULL(45,46)
  JVS(418) = 0
! JVS(419) = Jac_FULL(45,47)
  JVS(419) = 0
! JVS(420) = Jac_FULL(45,48)
  JVS(420) = -B(71)+B(72)
! JVS(421) = Jac_FULL(45,49)
  JVS(421) = B(25)-B(81)
! JVS(422) = Jac_FULL(45,50)
  JVS(422) = -B(12)
! JVS(423) = Jac_FULL(45,51)
  JVS(423) = B(1)-B(8)-B(10)
! JVS(424) = Jac_FULL(46,4)
  JVS(424) = B(152)+B(153)
! JVS(425) = Jac_FULL(46,14)
  JVS(425) = B(161)
! JVS(426) = Jac_FULL(46,20)
  JVS(426) = B(240)+B(242)
! JVS(427) = Jac_FULL(46,26)
  JVS(427) = B(233)+B(234)+0.62*B(236)
! JVS(428) = Jac_FULL(46,31)
  JVS(428) = 0
! JVS(429) = Jac_FULL(46,35)
  JVS(429) = 0.21*B(251)+0.114*B(253)+0.967*B(257)
! JVS(430) = Jac_FULL(46,38)
  JVS(430) = B(141)+B(143)+B(145)
! JVS(431) = Jac_FULL(46,40)
  JVS(431) = 0
! JVS(432) = Jac_FULL(46,41)
  JVS(432) = 0.62*B(237)+0.114*B(254)
! JVS(433) = Jac_FULL(46,42)
  JVS(433) = -B(158)
! JVS(434) = Jac_FULL(46,43)
  JVS(434) = -B(154)
! JVS(435) = Jac_FULL(46,44)
  JVS(435) = -B(156)
! JVS(436) = Jac_FULL(46,45)
  JVS(436) = B(142)
! JVS(437) = Jac_FULL(46,46)
  JVS(437) = -B(148)-B(150)-B(155)-B(157)-B(159)-2*B(160)-B(188)
! JVS(438) = Jac_FULL(46,47)
  JVS(438) = -B(189)
! JVS(439) = Jac_FULL(46,48)
  JVS(439) = B(144)+B(162)+B(235)+B(241)+0.21*B(252)
! JVS(440) = Jac_FULL(46,49)
  JVS(440) = B(146)
! JVS(441) = Jac_FULL(46,50)
  JVS(441) = -B(149)
! JVS(442) = Jac_FULL(46,51)
  JVS(442) = -B(151)
! JVS(443) = Jac_FULL(47,16)
  JVS(443) = B(177)+B(178)
! JVS(444) = Jac_FULL(47,32)
  JVS(444) = 0.39*B(262)
! JVS(445) = Jac_FULL(47,34)
  JVS(445) = 0.25*B(243)+0.2*B(247)
! JVS(446) = Jac_FULL(47,35)
  JVS(446) = 0.25*B(251)+0.075*B(255)
! JVS(447) = Jac_FULL(47,37)
  JVS(447) = B(166)+B(168)+B(170)
! JVS(448) = Jac_FULL(47,40)
  JVS(448) = 0
! JVS(449) = Jac_FULL(47,41)
  JVS(449) = 0.2*B(248)+0.39*B(263)
! JVS(450) = Jac_FULL(47,42)
  JVS(450) = -B(185)
! JVS(451) = Jac_FULL(47,43)
  JVS(451) = -B(181)
! JVS(452) = Jac_FULL(47,44)
  JVS(452) = -B(183)
! JVS(453) = Jac_FULL(47,45)
  JVS(453) = B(167)+0.25*B(244)
! JVS(454) = Jac_FULL(47,46)
  JVS(454) = -B(188)
! JVS(455) = Jac_FULL(47,47)
  JVS(455) = -B(173)-B(175)-B(182)-B(184)-B(186)-2*B(187)-B(189)
! JVS(456) = Jac_FULL(47,48)
  JVS(456) = B(169)+0.25*B(252)
! JVS(457) = Jac_FULL(47,49)
  JVS(457) = B(171)+0.075*B(256)
! JVS(458) = Jac_FULL(47,50)
  JVS(458) = -B(174)
! JVS(459) = Jac_FULL(47,51)
  JVS(459) = -B(176)
! JVS(460) = Jac_FULL(48,2)
  JVS(460) = -B(266)
! JVS(461) = Jac_FULL(48,3)
  JVS(461) = 2*B(19)+B(66)
! JVS(462) = Jac_FULL(48,5)
  JVS(462) = -B(220)
! JVS(463) = Jac_FULL(48,6)
  JVS(463) = -B(270)
! JVS(464) = Jac_FULL(48,7)
  JVS(464) = -B(122)
! JVS(465) = Jac_FULL(48,9)
  JVS(465) = -B(268)
! JVS(466) = Jac_FULL(48,10)
  JVS(466) = -B(238)
! JVS(467) = Jac_FULL(48,11)
  JVS(467) = B(45)-B(46)
! JVS(468) = Jac_FULL(48,12)
  JVS(468) = 2*B(63)-B(64)+B(78)
! JVS(469) = Jac_FULL(48,13)
  JVS(469) = -B(139)
! JVS(470) = Jac_FULL(48,14)
  JVS(470) = -B(161)+B(163)
! JVS(471) = Jac_FULL(48,15)
  JVS(471) = -B(164)
! JVS(472) = Jac_FULL(48,16)
  JVS(472) = -B(179)
! JVS(473) = Jac_FULL(48,17)
  JVS(473) = -B(58)+0.39*B(89)
! JVS(474) = Jac_FULL(48,19)
  JVS(474) = 0
! JVS(475) = Jac_FULL(48,20)
  JVS(475) = -B(240)
! JVS(476) = Jac_FULL(48,21)
  JVS(476) = -B(107)+B(109)
! JVS(477) = Jac_FULL(48,24)
  JVS(477) = -B(119)+B(121)
! JVS(478) = Jac_FULL(48,25)
  JVS(478) = -B(110)
! JVS(479) = Jac_FULL(48,26)
  JVS(479) = -B(234)+0.08*B(236)
! JVS(480) = Jac_FULL(48,27)
  JVS(480) = -B(51)+B(90)
! JVS(481) = Jac_FULL(48,28)
  JVS(481) = 0.3*B(204)-B(206)+0.13*B(208)
! JVS(482) = Jac_FULL(48,29)
  JVS(482) = -B(214)+0.5*B(216)
! JVS(483) = Jac_FULL(48,30)
  JVS(483) = 0.1*B(196)-B(198)+0.1*B(200)
! JVS(484) = Jac_FULL(48,31)
  JVS(484) = -B(225)
! JVS(485) = Jac_FULL(48,32)
  JVS(485) = -B(260)+0.57*B(262)
! JVS(486) = Jac_FULL(48,33)
  JVS(486) = -B(190)
! JVS(487) = Jac_FULL(48,34)
  JVS(487) = -B(245)+0.266*B(247)
! JVS(488) = Jac_FULL(48,35)
  JVS(488) = -B(251)+0.268*B(253)
! JVS(489) = Jac_FULL(48,36)
  JVS(489) = 0
! JVS(490) = Jac_FULL(48,37)
  JVS(490) = B(166)-B(168)
! JVS(491) = Jac_FULL(48,38)
  JVS(491) = B(141)-B(143)
! JVS(492) = Jac_FULL(48,39)
  JVS(492) = -B(124)+B(128)
! JVS(493) = Jac_FULL(48,40)
  JVS(493) = -B(104)
! JVS(494) = Jac_FULL(48,41)
  JVS(494) = -B(21)+B(23)+0.1*B(201)+0.13*B(209)+0.5*B(217)+0.08*B(237)+0.266*B(248)+0.268*B(254)+0.57*B(263)
! JVS(495) = Jac_FULL(48,42)
  JVS(495) = 0
! JVS(496) = Jac_FULL(48,43)
  JVS(496) = B(24)+B(53)-B(74)+B(76)
! JVS(497) = Jac_FULL(48,44)
  JVS(497) = 0
! JVS(498) = Jac_FULL(48,45)
  JVS(498) = -B(70)+B(77)+B(79)+B(129)+B(142)+B(167)+0.1*B(197)+0.3*B(205)
! JVS(499) = Jac_FULL(48,46)
  JVS(499) = 0
! JVS(500) = Jac_FULL(48,47)
  JVS(500) = 0
! JVS(501) = Jac_FULL(48,48)
  JVS(501) = -B(22)-B(43)-B(47)-B(49)-B(52)-B(59)-B(65)-B(68)-B(71)-2*B(72)-2*B(73)-B(75)-B(82)-B(105)-B(108)-B(111)&
               &-B(112)-B(120)-B(123)-B(125)-B(140)-B(144)-B(162)-B(165)-B(169)-B(180)-B(191)-B(199)-B(207)-B(215)-B(221)&
               &-B(226)-B(235)-B(239)-B(241)-B(246)-B(252)-B(261)-B(267)-B(269)-B(271)
! JVS(502) = Jac_FULL(48,49)
  JVS(502) = -B(83)
! JVS(503) = Jac_FULL(48,50)
  JVS(503) = -B(44)+B(54)
! JVS(504) = Jac_FULL(48,51)
  JVS(504) = -B(50)
! JVS(505) = Jac_FULL(49,8)
  JVS(505) = B(37)+B(91)
! JVS(506) = Jac_FULL(49,17)
  JVS(506) = 0.39*B(89)
! JVS(507) = Jac_FULL(49,27)
  JVS(507) = B(51)
! JVS(508) = Jac_FULL(49,28)
  JVS(508) = -B(210)
! JVS(509) = Jac_FULL(49,29)
  JVS(509) = -B(218)
! JVS(510) = Jac_FULL(49,30)
  JVS(510) = -B(202)
! JVS(511) = Jac_FULL(49,31)
  JVS(511) = -B(227)
! JVS(512) = Jac_FULL(49,32)
  JVS(512) = -B(264)
! JVS(513) = Jac_FULL(49,34)
  JVS(513) = -B(249)
! JVS(514) = Jac_FULL(49,35)
  JVS(514) = -B(255)
! JVS(515) = Jac_FULL(49,37)
  JVS(515) = -B(170)
! JVS(516) = Jac_FULL(49,38)
  JVS(516) = -B(145)
! JVS(517) = Jac_FULL(49,39)
  JVS(517) = -B(130)
! JVS(518) = Jac_FULL(49,40)
  JVS(518) = 0
! JVS(519) = Jac_FULL(49,41)
  JVS(519) = B(13)-B(86)
! JVS(520) = Jac_FULL(49,42)
  JVS(520) = 0
! JVS(521) = Jac_FULL(49,43)
  JVS(521) = -B(84)
! JVS(522) = Jac_FULL(49,44)
  JVS(522) = 0
! JVS(523) = Jac_FULL(49,45)
  JVS(523) = B(9)-B(80)
! JVS(524) = Jac_FULL(49,46)
  JVS(524) = 0
! JVS(525) = Jac_FULL(49,47)
  JVS(525) = 0
! JVS(526) = Jac_FULL(49,48)
  JVS(526) = B(52)-B(82)
! JVS(527) = Jac_FULL(49,49)
  JVS(527) = -B(25)-B(26)-B(27)-B(29)-B(31)-B(81)-B(83)-B(85)-B(87)-2*B(88)-B(131)-B(146)-B(171)-B(203)-B(211)-B(219)&
               &-B(228)-B(250)-B(256)-B(265)
! JVS(528) = Jac_FULL(49,50)
  JVS(528) = -B(28)
! JVS(529) = Jac_FULL(49,51)
  JVS(529) = B(10)+B(14)-B(30)-B(32)
! JVS(530) = Jac_FULL(50,11)
  JVS(530) = B(45)+B(48)
! JVS(531) = Jac_FULL(50,18)
  JVS(531) = -B(222)
! JVS(532) = Jac_FULL(50,19)
  JVS(532) = -B(135)
! JVS(533) = Jac_FULL(50,34)
  JVS(533) = 0.2*B(272)
! JVS(534) = Jac_FULL(50,36)
  JVS(534) = -B(94)
! JVS(535) = Jac_FULL(50,39)
  JVS(535) = 0
! JVS(536) = Jac_FULL(50,40)
  JVS(536) = 0
! JVS(537) = Jac_FULL(50,41)
  JVS(537) = -B(5)
! JVS(538) = Jac_FULL(50,42)
  JVS(538) = -B(92)
! JVS(539) = Jac_FULL(50,43)
  JVS(539) = -B(53)
! JVS(540) = Jac_FULL(50,44)
  JVS(540) = -B(114)
! JVS(541) = Jac_FULL(50,45)
  JVS(541) = B(7)-B(11)
! JVS(542) = Jac_FULL(50,46)
  JVS(542) = -B(148)
! JVS(543) = Jac_FULL(50,47)
  JVS(543) = -B(173)
! JVS(544) = Jac_FULL(50,48)
  JVS(544) = -B(43)
! JVS(545) = Jac_FULL(50,49)
  JVS(545) = B(26)-B(27)+B(29)
! JVS(546) = Jac_FULL(50,50)
  JVS(546) = -B(6)-B(12)-B(28)-2*B(38)-B(40)-B(44)-B(54)-B(93)-B(95)-B(115)-B(136)-B(149)-B(174)-B(223)
! JVS(547) = Jac_FULL(50,51)
  JVS(547) = B(1)+B(8)+B(30)-B(41)+0.2*B(273)
! JVS(548) = Jac_FULL(51,4)
  JVS(548) = B(152)+B(153)
! JVS(549) = Jac_FULL(51,8)
  JVS(549) = B(37)+B(91)
! JVS(550) = Jac_FULL(51,11)
  JVS(550) = B(46)+B(48)
! JVS(551) = Jac_FULL(51,16)
  JVS(551) = B(177)+B(178)+B(179)
! JVS(552) = Jac_FULL(51,17)
  JVS(552) = B(57)+B(58)+0.61*B(89)
! JVS(553) = Jac_FULL(51,18)
  JVS(553) = 0.9*B(222)
! JVS(554) = Jac_FULL(51,19)
  JVS(554) = B(135)
! JVS(555) = Jac_FULL(51,22)
  JVS(555) = -B(229)
! JVS(556) = Jac_FULL(51,23)
  JVS(556) = -B(194)
! JVS(557) = Jac_FULL(51,27)
  JVS(557) = B(90)
! JVS(558) = Jac_FULL(51,28)
  JVS(558) = B(210)
! JVS(559) = Jac_FULL(51,29)
  JVS(559) = B(218)
! JVS(560) = Jac_FULL(51,30)
  JVS(560) = B(202)
! JVS(561) = Jac_FULL(51,31)
  JVS(561) = 0
! JVS(562) = Jac_FULL(51,32)
  JVS(562) = 0.47*B(264)
! JVS(563) = Jac_FULL(51,33)
  JVS(563) = 0
! JVS(564) = Jac_FULL(51,34)
  JVS(564) = 0.2*B(249)-B(272)
! JVS(565) = Jac_FULL(51,35)
  JVS(565) = 0
! JVS(566) = Jac_FULL(51,37)
  JVS(566) = 0
! JVS(567) = Jac_FULL(51,38)
  JVS(567) = 0
! JVS(568) = Jac_FULL(51,39)
  JVS(568) = 0
! JVS(569) = Jac_FULL(51,40)
  JVS(569) = B(106)
! JVS(570) = Jac_FULL(51,41)
  JVS(570) = B(5)-B(13)+B(86)
! JVS(571) = Jac_FULL(51,42)
  JVS(571) = B(92)
! JVS(572) = Jac_FULL(51,43)
  JVS(572) = B(53)-B(55)
! JVS(573) = Jac_FULL(51,44)
  JVS(573) = B(114)
! JVS(574) = Jac_FULL(51,45)
  JVS(574) = -B(7)-B(9)+B(11)+B(80)
! JVS(575) = Jac_FULL(51,46)
  JVS(575) = B(148)-B(150)
! JVS(576) = Jac_FULL(51,47)
  JVS(576) = B(173)-B(175)
! JVS(577) = Jac_FULL(51,48)
  JVS(577) = B(47)-B(49)+B(59)+B(82)+B(180)
! JVS(578) = Jac_FULL(51,49)
  JVS(578) = B(25)+2*B(27)-B(31)+B(81)+B(83)+B(87)+2*B(88)+B(203)+B(211)+B(219)+0.2*B(250)+0.47*B(265)
! JVS(579) = Jac_FULL(51,50)
  JVS(579) = B(6)+B(12)+2*B(28)+2*B(38)-B(40)+B(54)+B(93)+B(115)+B(136)+B(149)+B(174)+0.9*B(223)
! JVS(580) = Jac_FULL(51,51)
  JVS(580) = -B(1)-B(8)-B(10)-B(14)-B(32)-B(41)-B(50)-B(56)-B(151)-B(176)-B(195)-B(230)-B(273)
      
END SUBROUTINE Jac_SP

! End of Jac_SP function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Jac_SP_Vec - function for sparse multiplication: sparse Jacobian times vector
!   Arguments :
!      JVS       - sparse Jacobian of variables
!      UV        - User vector for variables
!      JUV       - Jacobian times user vector
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE Jac_SP_Vec ( JVS, UV, JUV )

! JVS - sparse Jacobian of variables
  REAL(kind=dp) :: JVS(LU_NONZERO)
! UV - User vector for variables
  REAL(kind=dp) :: UV(NVAR)
! JUV - Jacobian times user vector
  REAL(kind=dp) :: JUV(NVAR)

  JUV(1) = JVS(1)*UV(1)+JVS(2)*UV(2)+JVS(3)*UV(48)
  JUV(2) = JVS(4)*UV(2)+JVS(5)*UV(48)
  JUV(3) = JVS(6)*UV(3)+JVS(7)*UV(41)
  JUV(4) = JVS(8)*UV(4)+JVS(9)*UV(46)+JVS(10)*UV(51)
  JUV(5) = JVS(11)*UV(5)+JVS(12)*UV(48)
  JUV(6) = JVS(13)*UV(6)+JVS(14)*UV(48)
  JUV(7) = JVS(15)*UV(7)+JVS(16)*UV(44)+JVS(17)*UV(48)
  JUV(8) = JVS(18)*UV(8)+JVS(19)*UV(49)+JVS(20)*UV(51)
  JUV(9) = JVS(21)*UV(9)+JVS(22)*UV(48)
  JUV(10) = JVS(23)*UV(10)+JVS(24)*UV(48)
  JUV(11) = JVS(25)*UV(11)+JVS(26)*UV(48)+JVS(27)*UV(50)+JVS(28)*UV(51)
  JUV(12) = JVS(29)*UV(12)+JVS(30)*UV(43)+JVS(31)*UV(45)+JVS(32)*UV(48)
  JUV(13) = JVS(33)*UV(13)+JVS(34)*UV(19)+JVS(35)*UV(28)+JVS(36)*UV(41)+JVS(37)*UV(48)+JVS(38)*UV(50)
  JUV(14) = JVS(39)*UV(14)+JVS(40)*UV(43)+JVS(41)*UV(46)+JVS(42)*UV(47)+JVS(43)*UV(48)
  JUV(15) = JVS(44)*UV(15)+JVS(45)*UV(42)+JVS(46)*UV(43)+JVS(47)*UV(44)+JVS(48)*UV(46)+JVS(49)*UV(47)+JVS(50)*UV(48)
  JUV(16) = JVS(51)*UV(16)+JVS(52)*UV(47)+JVS(53)*UV(48)+JVS(54)*UV(51)
  JUV(17) = JVS(55)*UV(17)+JVS(56)*UV(43)+JVS(57)*UV(48)+JVS(58)*UV(51)
  JUV(18) = JVS(59)*UV(5)+JVS(60)*UV(10)+JVS(61)*UV(18)+JVS(62)*UV(48)+JVS(63)*UV(50)
  JUV(19) = JVS(64)*UV(19)+JVS(65)*UV(39)+JVS(66)*UV(43)+JVS(67)*UV(50)
  JUV(20) = JVS(68)*UV(10)+JVS(69)*UV(20)+JVS(70)*UV(26)+JVS(71)*UV(35)+JVS(72)*UV(41)+JVS(73)*UV(48)
  JUV(21) = JVS(74)*UV(21)+JVS(75)*UV(36)+JVS(76)*UV(42)+JVS(77)*UV(43)+JVS(78)*UV(48)
  JUV(22) = JVS(79)*UV(22)+JVS(80)*UV(31)+JVS(81)*UV(43)+JVS(82)*UV(48)+JVS(83)*UV(49)+JVS(84)*UV(51)
  JUV(23) = JVS(85)*UV(23)+JVS(86)*UV(33)+JVS(87)*UV(48)+JVS(88)*UV(51)
  JUV(24) = JVS(89)*UV(19)+JVS(90)*UV(24)+JVS(92)*UV(43)+JVS(93)*UV(44)+JVS(94)*UV(48)
  JUV(25) = JVS(96)*UV(20)+JVS(97)*UV(25)+JVS(98)*UV(26)+JVS(99)*UV(28)+JVS(100)*UV(29)+JVS(101)*UV(30)+JVS(102)*UV(32)&
              &+JVS(103)*UV(34)+JVS(104)*UV(35)+JVS(105)*UV(37)+JVS(106)*UV(38)+JVS(107)*UV(39)+JVS(108)*UV(41)+JVS(109)&
              &*UV(45)+JVS(110)*UV(48)+JVS(111)*UV(49)
  JUV(26) = JVS(112)*UV(18)+JVS(113)*UV(26)+JVS(114)*UV(31)+JVS(115)*UV(41)+JVS(116)*UV(48)+JVS(117)*UV(50)
  JUV(27) = JVS(118)*UV(8)+JVS(119)*UV(27)+JVS(120)*UV(31)+JVS(121)*UV(35)+JVS(122)*UV(37)+JVS(123)*UV(38)+JVS(124)&
              &*UV(39)+JVS(125)*UV(40)+JVS(126)*UV(43)+JVS(127)*UV(48)+JVS(128)*UV(49)+JVS(129)*UV(51)
  JUV(28) = JVS(130)*UV(28)+JVS(131)*UV(41)+JVS(132)*UV(45)+JVS(133)*UV(48)+JVS(134)*UV(49)
  JUV(29) = JVS(135)*UV(29)+JVS(136)*UV(41)+JVS(137)*UV(45)+JVS(138)*UV(48)+JVS(139)*UV(49)
  JUV(30) = JVS(140)*UV(30)+JVS(141)*UV(41)+JVS(142)*UV(45)+JVS(143)*UV(48)+JVS(144)*UV(49)
  JUV(31) = JVS(145)*UV(5)+JVS(146)*UV(10)+JVS(147)*UV(18)+JVS(148)*UV(22)+JVS(149)*UV(31)+JVS(150)*UV(43)+JVS(151)&
              &*UV(48)+JVS(152)*UV(49)
  JUV(32) = JVS(155)*UV(32)+JVS(156)*UV(41)+JVS(157)*UV(45)+JVS(158)*UV(48)+JVS(159)*UV(49)
  JUV(33) = JVS(160)*UV(10)+JVS(161)*UV(23)+JVS(162)*UV(29)+JVS(163)*UV(30)+JVS(164)*UV(32)+JVS(165)*UV(33)+JVS(166)&
              &*UV(34)+JVS(167)*UV(35)+JVS(168)*UV(40)+JVS(169)*UV(41)+JVS(170)*UV(45)+JVS(171)*UV(48)+JVS(172)*UV(49)&
              &+JVS(173)*UV(51)
  JUV(34) = JVS(174)*UV(34)+JVS(175)*UV(41)+JVS(176)*UV(45)+JVS(177)*UV(48)+JVS(178)*UV(49)+JVS(179)*UV(51)
  JUV(35) = JVS(180)*UV(34)+JVS(181)*UV(35)+JVS(182)*UV(41)+JVS(183)*UV(45)+JVS(184)*UV(48)+JVS(185)*UV(49)+JVS(186)&
              &*UV(51)
  JUV(36) = JVS(187)*UV(6)+JVS(188)*UV(23)+JVS(189)*UV(30)+JVS(190)*UV(32)+JVS(191)*UV(33)+JVS(192)*UV(34)+JVS(194)&
              &*UV(36)+JVS(196)*UV(41)+JVS(197)*UV(42)+JVS(198)*UV(43)+JVS(199)*UV(45)+JVS(200)*UV(48)+JVS(201)*UV(49)&
              &+JVS(202)*UV(50)
  JUV(37) = JVS(204)*UV(9)+JVS(205)*UV(21)+JVS(206)*UV(23)+JVS(207)*UV(26)+JVS(208)*UV(28)+JVS(209)*UV(29)+JVS(210)&
              &*UV(30)+JVS(212)*UV(32)+JVS(213)*UV(33)+JVS(214)*UV(34)+JVS(215)*UV(35)+JVS(217)*UV(37)+JVS(218)*UV(40)&
              &+JVS(219)*UV(41)+JVS(222)*UV(45)+JVS(223)*UV(48)+JVS(224)*UV(49)+JVS(226)*UV(51)
  JUV(38) = JVS(227)*UV(6)+JVS(228)*UV(9)+JVS(229)*UV(16)+JVS(230)*UV(21)+JVS(231)*UV(23)+JVS(232)*UV(29)+JVS(233)&
              &*UV(30)+JVS(234)*UV(33)+JVS(236)*UV(35)+JVS(238)*UV(38)+JVS(239)*UV(40)+JVS(240)*UV(41)+JVS(241)*UV(42)&
              &+JVS(243)*UV(44)+JVS(244)*UV(45)+JVS(245)*UV(46)+JVS(246)*UV(47)+JVS(247)*UV(48)+JVS(248)*UV(49)+JVS(249)&
              &*UV(50)
  JUV(39) = JVS(251)*UV(7)+JVS(252)*UV(9)+JVS(253)*UV(19)+JVS(254)*UV(24)+JVS(255)*UV(26)+JVS(256)*UV(28)+JVS(257)&
              &*UV(29)+JVS(258)*UV(30)+JVS(260)*UV(32)+JVS(261)*UV(34)+JVS(262)*UV(35)+JVS(263)*UV(39)+JVS(264)*UV(40)&
              &+JVS(265)*UV(41)+JVS(266)*UV(43)+JVS(267)*UV(44)+JVS(268)*UV(45)+JVS(269)*UV(46)+JVS(270)*UV(47)+JVS(271)&
              &*UV(48)+JVS(272)*UV(49)+JVS(273)*UV(50)
  JUV(40) = JVS(275)*UV(18)+JVS(276)*UV(22)+JVS(277)*UV(23)+JVS(279)*UV(32)+JVS(281)*UV(34)+JVS(282)*UV(35)+JVS(283)&
              &*UV(36)+JVS(284)*UV(40)+JVS(289)*UV(48)+JVS(290)*UV(49)+JVS(291)*UV(50)+JVS(292)*UV(51)
  JUV(41) = JVS(293)*UV(26)+JVS(294)*UV(28)+JVS(295)*UV(29)+JVS(296)*UV(30)+JVS(298)*UV(32)+JVS(299)*UV(34)+JVS(300)&
              &*UV(35)+JVS(301)*UV(41)+JVS(302)*UV(43)+JVS(303)*UV(45)+JVS(304)*UV(46)+JVS(305)*UV(47)+JVS(306)*UV(48)&
              &+JVS(307)*UV(49)+JVS(308)*UV(50)+JVS(309)*UV(51)
  JUV(42) = JVS(310)*UV(5)+JVS(311)*UV(6)+JVS(312)*UV(9)+JVS(313)*UV(10)+JVS(314)*UV(20)+JVS(315)*UV(21)+JVS(316)*UV(23)&
              &+JVS(317)*UV(24)+JVS(318)*UV(26)+JVS(319)*UV(28)+JVS(320)*UV(29)+JVS(321)*UV(30)+JVS(322)*UV(31)+JVS(323)&
              &*UV(32)+JVS(324)*UV(33)+JVS(325)*UV(34)+JVS(326)*UV(35)+JVS(327)*UV(36)+JVS(330)*UV(41)+JVS(331)*UV(42)&
              &+JVS(332)*UV(43)+JVS(333)*UV(44)+JVS(334)*UV(45)+JVS(335)*UV(46)+JVS(336)*UV(47)+JVS(337)*UV(48)+JVS(338)&
              &*UV(49)+JVS(339)*UV(50)+JVS(340)*UV(51)
  JUV(43) = JVS(341)*UV(2)+JVS(342)*UV(3)+JVS(343)*UV(5)+JVS(344)*UV(6)+JVS(345)*UV(7)+JVS(346)*UV(9)+JVS(347)*UV(10)&
              &+JVS(348)*UV(12)+JVS(349)*UV(13)+JVS(350)*UV(17)+JVS(351)*UV(18)+JVS(352)*UV(19)+JVS(353)*UV(20)+JVS(354)&
              &*UV(21)+JVS(355)*UV(22)+JVS(356)*UV(23)+JVS(357)*UV(24)+JVS(358)*UV(25)+JVS(359)*UV(26)+JVS(360)*UV(28)&
              &+JVS(361)*UV(29)+JVS(362)*UV(30)+JVS(363)*UV(31)+JVS(364)*UV(32)+JVS(365)*UV(33)+JVS(366)*UV(34)+JVS(367)&
              &*UV(35)+JVS(368)*UV(36)+JVS(369)*UV(37)+JVS(370)*UV(38)+JVS(371)*UV(39)+JVS(372)*UV(40)+JVS(373)*UV(41)&
              &+JVS(374)*UV(42)+JVS(375)*UV(43)+JVS(376)*UV(44)+JVS(377)*UV(45)+JVS(378)*UV(46)+JVS(379)*UV(47)+JVS(380)&
              &*UV(48)+JVS(381)*UV(49)+JVS(382)*UV(50)+JVS(383)*UV(51)
  JUV(44) = JVS(384)*UV(14)+JVS(385)*UV(15)+JVS(386)*UV(24)+JVS(387)*UV(37)+JVS(388)*UV(38)+JVS(392)*UV(42)+JVS(393)&
              &*UV(43)+JVS(394)*UV(44)+JVS(396)*UV(46)+JVS(397)*UV(47)+JVS(398)*UV(48)+JVS(400)*UV(50)
  JUV(45) = JVS(402)*UV(3)+JVS(403)*UV(12)+JVS(404)*UV(28)+JVS(405)*UV(29)+JVS(406)*UV(30)+JVS(407)*UV(32)+JVS(408)&
              &*UV(34)+JVS(409)*UV(37)+JVS(410)*UV(38)+JVS(411)*UV(39)+JVS(413)*UV(41)+JVS(415)*UV(43)+JVS(417)*UV(45)&
              &+JVS(420)*UV(48)+JVS(421)*UV(49)+JVS(422)*UV(50)+JVS(423)*UV(51)
  JUV(46) = JVS(424)*UV(4)+JVS(425)*UV(14)+JVS(426)*UV(20)+JVS(427)*UV(26)+JVS(429)*UV(35)+JVS(430)*UV(38)+JVS(432)&
              &*UV(41)+JVS(433)*UV(42)+JVS(434)*UV(43)+JVS(435)*UV(44)+JVS(436)*UV(45)+JVS(437)*UV(46)+JVS(438)*UV(47)&
              &+JVS(439)*UV(48)+JVS(440)*UV(49)+JVS(441)*UV(50)+JVS(442)*UV(51)
  JUV(47) = JVS(443)*UV(16)+JVS(444)*UV(32)+JVS(445)*UV(34)+JVS(446)*UV(35)+JVS(447)*UV(37)+JVS(449)*UV(41)+JVS(450)&
              &*UV(42)+JVS(451)*UV(43)+JVS(452)*UV(44)+JVS(453)*UV(45)+JVS(454)*UV(46)+JVS(455)*UV(47)+JVS(456)*UV(48)&
              &+JVS(457)*UV(49)+JVS(458)*UV(50)+JVS(459)*UV(51)
  JUV(48) = JVS(460)*UV(2)+JVS(461)*UV(3)+JVS(462)*UV(5)+JVS(463)*UV(6)+JVS(464)*UV(7)+JVS(465)*UV(9)+JVS(466)*UV(10)&
              &+JVS(467)*UV(11)+JVS(468)*UV(12)+JVS(469)*UV(13)+JVS(470)*UV(14)+JVS(471)*UV(15)+JVS(472)*UV(16)+JVS(473)&
              &*UV(17)+JVS(475)*UV(20)+JVS(476)*UV(21)+JVS(477)*UV(24)+JVS(478)*UV(25)+JVS(479)*UV(26)+JVS(480)*UV(27)&
              &+JVS(481)*UV(28)+JVS(482)*UV(29)+JVS(483)*UV(30)+JVS(484)*UV(31)+JVS(485)*UV(32)+JVS(486)*UV(33)+JVS(487)&
              &*UV(34)+JVS(488)*UV(35)+JVS(490)*UV(37)+JVS(491)*UV(38)+JVS(492)*UV(39)+JVS(493)*UV(40)+JVS(494)*UV(41)&
              &+JVS(496)*UV(43)+JVS(498)*UV(45)+JVS(501)*UV(48)+JVS(502)*UV(49)+JVS(503)*UV(50)+JVS(504)*UV(51)
  JUV(49) = JVS(505)*UV(8)+JVS(506)*UV(17)+JVS(507)*UV(27)+JVS(508)*UV(28)+JVS(509)*UV(29)+JVS(510)*UV(30)+JVS(511)&
              &*UV(31)+JVS(512)*UV(32)+JVS(513)*UV(34)+JVS(514)*UV(35)+JVS(515)*UV(37)+JVS(516)*UV(38)+JVS(517)*UV(39)&
              &+JVS(519)*UV(41)+JVS(521)*UV(43)+JVS(523)*UV(45)+JVS(526)*UV(48)+JVS(527)*UV(49)+JVS(528)*UV(50)+JVS(529)&
              &*UV(51)
  JUV(50) = JVS(530)*UV(11)+JVS(531)*UV(18)+JVS(532)*UV(19)+JVS(533)*UV(34)+JVS(534)*UV(36)+JVS(537)*UV(41)+JVS(538)&
              &*UV(42)+JVS(539)*UV(43)+JVS(540)*UV(44)+JVS(541)*UV(45)+JVS(542)*UV(46)+JVS(543)*UV(47)+JVS(544)*UV(48)&
              &+JVS(545)*UV(49)+JVS(546)*UV(50)+JVS(547)*UV(51)
  JUV(51) = JVS(548)*UV(4)+JVS(549)*UV(8)+JVS(550)*UV(11)+JVS(551)*UV(16)+JVS(552)*UV(17)+JVS(553)*UV(18)+JVS(554)&
              &*UV(19)+JVS(555)*UV(22)+JVS(556)*UV(23)+JVS(557)*UV(27)+JVS(558)*UV(28)+JVS(559)*UV(29)+JVS(560)*UV(30)&
              &+JVS(562)*UV(32)+JVS(564)*UV(34)+JVS(569)*UV(40)+JVS(570)*UV(41)+JVS(571)*UV(42)+JVS(572)*UV(43)+JVS(573)&
              &*UV(44)+JVS(574)*UV(45)+JVS(575)*UV(46)+JVS(576)*UV(47)+JVS(577)*UV(48)+JVS(578)*UV(49)+JVS(579)*UV(50)&
              &+JVS(580)*UV(51)
      
END SUBROUTINE Jac_SP_Vec

! End of Jac_SP_Vec function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! JacTR_SP_Vec - sparse multiplication: sparse Jacobian transposed times vector
!   Arguments :
!      JVS       - sparse Jacobian of variables
!      UV        - User vector for variables
!      JTUV      - Jacobian transposed times user vector
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE JacTR_SP_Vec ( JVS, UV, JTUV )

! JVS - sparse Jacobian of variables
  REAL(kind=dp) :: JVS(LU_NONZERO)
! UV - User vector for variables
  REAL(kind=dp) :: UV(NVAR)
! JTUV - Jacobian transposed times user vector
  REAL(kind=dp) :: JTUV(NVAR)

  JTUV(1) = JVS(1)*UV(1)
  JTUV(2) = JVS(2)*UV(1)+JVS(4)*UV(2)+JVS(341)*UV(43)+JVS(460)*UV(48)
  JTUV(3) = JVS(6)*UV(3)+JVS(342)*UV(43)+JVS(402)*UV(45)+JVS(461)*UV(48)
  JTUV(4) = JVS(8)*UV(4)+JVS(424)*UV(46)+JVS(548)*UV(51)
  JTUV(5) = JVS(11)*UV(5)+JVS(59)*UV(18)+JVS(145)*UV(31)+JVS(310)*UV(42)+JVS(343)*UV(43)+JVS(462)*UV(48)
  JTUV(6) = JVS(13)*UV(6)+JVS(187)*UV(36)+JVS(227)*UV(38)+JVS(311)*UV(42)+JVS(344)*UV(43)+JVS(463)*UV(48)
  JTUV(7) = JVS(15)*UV(7)+JVS(251)*UV(39)+JVS(345)*UV(43)+JVS(464)*UV(48)
  JTUV(8) = JVS(18)*UV(8)+JVS(118)*UV(27)+JVS(505)*UV(49)+JVS(549)*UV(51)
  JTUV(9) = JVS(21)*UV(9)+JVS(204)*UV(37)+JVS(228)*UV(38)+JVS(252)*UV(39)+JVS(312)*UV(42)+JVS(346)*UV(43)+JVS(465)&
              &*UV(48)
  JTUV(10) = JVS(23)*UV(10)+JVS(60)*UV(18)+JVS(68)*UV(20)+JVS(146)*UV(31)+JVS(160)*UV(33)+JVS(313)*UV(42)+JVS(347)&
               &*UV(43)+JVS(466)*UV(48)
  JTUV(11) = JVS(25)*UV(11)+JVS(467)*UV(48)+JVS(530)*UV(50)+JVS(550)*UV(51)
  JTUV(12) = JVS(29)*UV(12)+JVS(348)*UV(43)+JVS(403)*UV(45)+JVS(468)*UV(48)
  JTUV(13) = JVS(33)*UV(13)+JVS(349)*UV(43)+JVS(469)*UV(48)
  JTUV(14) = JVS(39)*UV(14)+JVS(384)*UV(44)+JVS(425)*UV(46)+JVS(470)*UV(48)
  JTUV(15) = JVS(44)*UV(15)+JVS(385)*UV(44)+JVS(471)*UV(48)
  JTUV(16) = JVS(51)*UV(16)+JVS(229)*UV(38)+JVS(443)*UV(47)+JVS(472)*UV(48)+JVS(551)*UV(51)
  JTUV(17) = JVS(55)*UV(17)+JVS(350)*UV(43)+JVS(473)*UV(48)+JVS(506)*UV(49)+JVS(552)*UV(51)
  JTUV(18) = JVS(61)*UV(18)+JVS(112)*UV(26)+JVS(147)*UV(31)+JVS(275)*UV(40)+JVS(351)*UV(43)+JVS(531)*UV(50)+JVS(553)&
               &*UV(51)
  JTUV(19) = JVS(34)*UV(13)+JVS(64)*UV(19)+JVS(89)*UV(24)+JVS(253)*UV(39)+JVS(352)*UV(43)+JVS(532)*UV(50)+JVS(554)&
               &*UV(51)
  JTUV(20) = JVS(69)*UV(20)+JVS(96)*UV(25)+JVS(314)*UV(42)+JVS(353)*UV(43)+JVS(426)*UV(46)+JVS(475)*UV(48)
  JTUV(21) = JVS(74)*UV(21)+JVS(205)*UV(37)+JVS(230)*UV(38)+JVS(315)*UV(42)+JVS(354)*UV(43)+JVS(476)*UV(48)
  JTUV(22) = JVS(79)*UV(22)+JVS(148)*UV(31)+JVS(276)*UV(40)+JVS(355)*UV(43)+JVS(555)*UV(51)
  JTUV(23) = JVS(85)*UV(23)+JVS(161)*UV(33)+JVS(188)*UV(36)+JVS(206)*UV(37)+JVS(231)*UV(38)+JVS(277)*UV(40)+JVS(316)&
               &*UV(42)+JVS(356)*UV(43)+JVS(556)*UV(51)
  JTUV(24) = JVS(90)*UV(24)+JVS(254)*UV(39)+JVS(317)*UV(42)+JVS(357)*UV(43)+JVS(386)*UV(44)+JVS(477)*UV(48)
  JTUV(25) = JVS(97)*UV(25)+JVS(358)*UV(43)+JVS(478)*UV(48)
  JTUV(26) = JVS(70)*UV(20)+JVS(98)*UV(25)+JVS(113)*UV(26)+JVS(207)*UV(37)+JVS(255)*UV(39)+JVS(293)*UV(41)+JVS(318)&
               &*UV(42)+JVS(359)*UV(43)+JVS(427)*UV(46)+JVS(479)*UV(48)
  JTUV(27) = JVS(119)*UV(27)+JVS(480)*UV(48)+JVS(507)*UV(49)+JVS(557)*UV(51)
  JTUV(28) = JVS(35)*UV(13)+JVS(99)*UV(25)+JVS(130)*UV(28)+JVS(208)*UV(37)+JVS(256)*UV(39)+JVS(294)*UV(41)+JVS(319)&
               &*UV(42)+JVS(360)*UV(43)+JVS(404)*UV(45)+JVS(481)*UV(48)+JVS(508)*UV(49)+JVS(558)*UV(51)
  JTUV(29) = JVS(100)*UV(25)+JVS(135)*UV(29)+JVS(162)*UV(33)+JVS(209)*UV(37)+JVS(232)*UV(38)+JVS(257)*UV(39)+JVS(295)&
               &*UV(41)+JVS(320)*UV(42)+JVS(361)*UV(43)+JVS(405)*UV(45)+JVS(482)*UV(48)+JVS(509)*UV(49)+JVS(559)*UV(51)
  JTUV(30) = JVS(101)*UV(25)+JVS(140)*UV(30)+JVS(163)*UV(33)+JVS(189)*UV(36)+JVS(210)*UV(37)+JVS(233)*UV(38)+JVS(258)&
               &*UV(39)+JVS(296)*UV(41)+JVS(321)*UV(42)+JVS(362)*UV(43)+JVS(406)*UV(45)+JVS(483)*UV(48)+JVS(510)*UV(49)&
               &+JVS(560)*UV(51)
  JTUV(31) = JVS(80)*UV(22)+JVS(114)*UV(26)+JVS(120)*UV(27)+JVS(149)*UV(31)+JVS(322)*UV(42)+JVS(363)*UV(43)+JVS(484)&
               &*UV(48)+JVS(511)*UV(49)
  JTUV(32) = JVS(102)*UV(25)+JVS(155)*UV(32)+JVS(164)*UV(33)+JVS(190)*UV(36)+JVS(212)*UV(37)+JVS(260)*UV(39)+JVS(279)&
               &*UV(40)+JVS(298)*UV(41)+JVS(323)*UV(42)+JVS(364)*UV(43)+JVS(407)*UV(45)+JVS(444)*UV(47)+JVS(485)*UV(48)&
               &+JVS(512)*UV(49)+JVS(562)*UV(51)
  JTUV(33) = JVS(86)*UV(23)+JVS(165)*UV(33)+JVS(191)*UV(36)+JVS(213)*UV(37)+JVS(234)*UV(38)+JVS(324)*UV(42)+JVS(365)&
               &*UV(43)+JVS(486)*UV(48)
  JTUV(34) = JVS(103)*UV(25)+JVS(166)*UV(33)+JVS(174)*UV(34)+JVS(180)*UV(35)+JVS(192)*UV(36)+JVS(214)*UV(37)+JVS(261)&
               &*UV(39)+JVS(281)*UV(40)+JVS(299)*UV(41)+JVS(325)*UV(42)+JVS(366)*UV(43)+JVS(408)*UV(45)+JVS(445)*UV(47)&
               &+JVS(487)*UV(48)+JVS(513)*UV(49)+JVS(533)*UV(50)+JVS(564)*UV(51)
  JTUV(35) = JVS(71)*UV(20)+JVS(104)*UV(25)+JVS(121)*UV(27)+JVS(167)*UV(33)+JVS(181)*UV(35)+JVS(215)*UV(37)+JVS(236)&
               &*UV(38)+JVS(262)*UV(39)+JVS(282)*UV(40)+JVS(300)*UV(41)+JVS(326)*UV(42)+JVS(367)*UV(43)+JVS(429)*UV(46)&
               &+JVS(446)*UV(47)+JVS(488)*UV(48)+JVS(514)*UV(49)
  JTUV(36) = JVS(75)*UV(21)+JVS(194)*UV(36)+JVS(283)*UV(40)+JVS(327)*UV(42)+JVS(368)*UV(43)+JVS(534)*UV(50)
  JTUV(37) = JVS(105)*UV(25)+JVS(122)*UV(27)+JVS(217)*UV(37)+JVS(369)*UV(43)+JVS(387)*UV(44)+JVS(409)*UV(45)+JVS(447)&
               &*UV(47)+JVS(490)*UV(48)+JVS(515)*UV(49)
  JTUV(38) = JVS(106)*UV(25)+JVS(123)*UV(27)+JVS(238)*UV(38)+JVS(370)*UV(43)+JVS(388)*UV(44)+JVS(410)*UV(45)+JVS(430)&
               &*UV(46)+JVS(491)*UV(48)+JVS(516)*UV(49)
  JTUV(39) = JVS(65)*UV(19)+JVS(107)*UV(25)+JVS(124)*UV(27)+JVS(263)*UV(39)+JVS(371)*UV(43)+JVS(411)*UV(45)+JVS(492)&
               &*UV(48)+JVS(517)*UV(49)
  JTUV(40) = JVS(125)*UV(27)+JVS(168)*UV(33)+JVS(218)*UV(37)+JVS(239)*UV(38)+JVS(264)*UV(39)+JVS(284)*UV(40)+JVS(372)&
               &*UV(43)+JVS(493)*UV(48)+JVS(569)*UV(51)
  JTUV(41) = JVS(7)*UV(3)+JVS(36)*UV(13)+JVS(72)*UV(20)+JVS(108)*UV(25)+JVS(115)*UV(26)+JVS(131)*UV(28)+JVS(136)*UV(29)&
               &+JVS(141)*UV(30)+JVS(156)*UV(32)+JVS(169)*UV(33)+JVS(175)*UV(34)+JVS(182)*UV(35)+JVS(196)*UV(36)+JVS(219)&
               &*UV(37)+JVS(240)*UV(38)+JVS(265)*UV(39)+JVS(301)*UV(41)+JVS(330)*UV(42)+JVS(373)*UV(43)+JVS(413)*UV(45)&
               &+JVS(432)*UV(46)+JVS(449)*UV(47)+JVS(494)*UV(48)+JVS(519)*UV(49)+JVS(537)*UV(50)+JVS(570)*UV(51)
  JTUV(42) = JVS(45)*UV(15)+JVS(76)*UV(21)+JVS(197)*UV(36)+JVS(241)*UV(38)+JVS(331)*UV(42)+JVS(374)*UV(43)+JVS(392)&
               &*UV(44)+JVS(433)*UV(46)+JVS(450)*UV(47)+JVS(538)*UV(50)+JVS(571)*UV(51)
  JTUV(43) = JVS(30)*UV(12)+JVS(40)*UV(14)+JVS(46)*UV(15)+JVS(56)*UV(17)+JVS(66)*UV(19)+JVS(77)*UV(21)+JVS(81)*UV(22)&
               &+JVS(92)*UV(24)+JVS(126)*UV(27)+JVS(150)*UV(31)+JVS(198)*UV(36)+JVS(266)*UV(39)+JVS(302)*UV(41)+JVS(332)&
               &*UV(42)+JVS(375)*UV(43)+JVS(393)*UV(44)+JVS(415)*UV(45)+JVS(434)*UV(46)+JVS(451)*UV(47)+JVS(496)*UV(48)&
               &+JVS(521)*UV(49)+JVS(539)*UV(50)+JVS(572)*UV(51)
  JTUV(44) = JVS(16)*UV(7)+JVS(47)*UV(15)+JVS(93)*UV(24)+JVS(243)*UV(38)+JVS(267)*UV(39)+JVS(333)*UV(42)+JVS(376)*UV(43)&
               &+JVS(394)*UV(44)+JVS(435)*UV(46)+JVS(452)*UV(47)+JVS(540)*UV(50)+JVS(573)*UV(51)
  JTUV(45) = JVS(31)*UV(12)+JVS(109)*UV(25)+JVS(132)*UV(28)+JVS(137)*UV(29)+JVS(142)*UV(30)+JVS(157)*UV(32)+JVS(170)&
               &*UV(33)+JVS(176)*UV(34)+JVS(183)*UV(35)+JVS(199)*UV(36)+JVS(222)*UV(37)+JVS(244)*UV(38)+JVS(268)*UV(39)&
               &+JVS(303)*UV(41)+JVS(334)*UV(42)+JVS(377)*UV(43)+JVS(417)*UV(45)+JVS(436)*UV(46)+JVS(453)*UV(47)+JVS(498)&
               &*UV(48)+JVS(523)*UV(49)+JVS(541)*UV(50)+JVS(574)*UV(51)
  JTUV(46) = JVS(9)*UV(4)+JVS(41)*UV(14)+JVS(48)*UV(15)+JVS(245)*UV(38)+JVS(269)*UV(39)+JVS(304)*UV(41)+JVS(335)*UV(42)&
               &+JVS(378)*UV(43)+JVS(396)*UV(44)+JVS(437)*UV(46)+JVS(454)*UV(47)+JVS(542)*UV(50)+JVS(575)*UV(51)
  JTUV(47) = JVS(42)*UV(14)+JVS(49)*UV(15)+JVS(52)*UV(16)+JVS(246)*UV(38)+JVS(270)*UV(39)+JVS(305)*UV(41)+JVS(336)&
               &*UV(42)+JVS(379)*UV(43)+JVS(397)*UV(44)+JVS(438)*UV(46)+JVS(455)*UV(47)+JVS(543)*UV(50)+JVS(576)*UV(51)
  JTUV(48) = JVS(3)*UV(1)+JVS(5)*UV(2)+JVS(12)*UV(5)+JVS(14)*UV(6)+JVS(17)*UV(7)+JVS(22)*UV(9)+JVS(24)*UV(10)+JVS(26)&
               &*UV(11)+JVS(32)*UV(12)+JVS(37)*UV(13)+JVS(43)*UV(14)+JVS(50)*UV(15)+JVS(53)*UV(16)+JVS(57)*UV(17)+JVS(62)&
               &*UV(18)+JVS(73)*UV(20)+JVS(78)*UV(21)+JVS(82)*UV(22)+JVS(87)*UV(23)+JVS(94)*UV(24)+JVS(110)*UV(25)+JVS(116)&
               &*UV(26)+JVS(127)*UV(27)+JVS(133)*UV(28)+JVS(138)*UV(29)+JVS(143)*UV(30)+JVS(151)*UV(31)+JVS(158)*UV(32)&
               &+JVS(171)*UV(33)+JVS(177)*UV(34)+JVS(184)*UV(35)+JVS(200)*UV(36)+JVS(223)*UV(37)+JVS(247)*UV(38)+JVS(271)&
               &*UV(39)+JVS(289)*UV(40)+JVS(306)*UV(41)+JVS(337)*UV(42)+JVS(380)*UV(43)+JVS(398)*UV(44)+JVS(420)*UV(45)&
               &+JVS(439)*UV(46)+JVS(456)*UV(47)+JVS(501)*UV(48)+JVS(526)*UV(49)+JVS(544)*UV(50)+JVS(577)*UV(51)
  JTUV(49) = JVS(19)*UV(8)+JVS(83)*UV(22)+JVS(111)*UV(25)+JVS(128)*UV(27)+JVS(134)*UV(28)+JVS(139)*UV(29)+JVS(144)&
               &*UV(30)+JVS(152)*UV(31)+JVS(159)*UV(32)+JVS(172)*UV(33)+JVS(178)*UV(34)+JVS(185)*UV(35)+JVS(201)*UV(36)&
               &+JVS(224)*UV(37)+JVS(248)*UV(38)+JVS(272)*UV(39)+JVS(290)*UV(40)+JVS(307)*UV(41)+JVS(338)*UV(42)+JVS(381)&
               &*UV(43)+JVS(421)*UV(45)+JVS(440)*UV(46)+JVS(457)*UV(47)+JVS(502)*UV(48)+JVS(527)*UV(49)+JVS(545)*UV(50)&
               &+JVS(578)*UV(51)
  JTUV(50) = JVS(27)*UV(11)+JVS(38)*UV(13)+JVS(63)*UV(18)+JVS(67)*UV(19)+JVS(117)*UV(26)+JVS(202)*UV(36)+JVS(249)*UV(38)&
               &+JVS(273)*UV(39)+JVS(291)*UV(40)+JVS(308)*UV(41)+JVS(339)*UV(42)+JVS(382)*UV(43)+JVS(400)*UV(44)+JVS(422)&
               &*UV(45)+JVS(441)*UV(46)+JVS(458)*UV(47)+JVS(503)*UV(48)+JVS(528)*UV(49)+JVS(546)*UV(50)+JVS(579)*UV(51)
  JTUV(51) = JVS(10)*UV(4)+JVS(20)*UV(8)+JVS(28)*UV(11)+JVS(54)*UV(16)+JVS(58)*UV(17)+JVS(84)*UV(22)+JVS(88)*UV(23)&
               &+JVS(129)*UV(27)+JVS(173)*UV(33)+JVS(179)*UV(34)+JVS(186)*UV(35)+JVS(226)*UV(37)+JVS(292)*UV(40)+JVS(309)&
               &*UV(41)+JVS(340)*UV(42)+JVS(383)*UV(43)+JVS(423)*UV(45)+JVS(442)*UV(46)+JVS(459)*UV(47)+JVS(504)*UV(48)&
               &+JVS(529)*UV(49)+JVS(547)*UV(50)+JVS(580)*UV(51)
      
END SUBROUTINE JacTR_SP_Vec

! End of JacTR_SP_Vec function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



END MODULE cbm5_Jacobian

