!
!-----------------------------------------------------------------------
!***  modelgrid.inc -  START
!-----------------------------------------------------------------------
!
!-----------------------------------------------------------------------
!***  model grid domain boundaries
!-----------------------------------------------------------------------
!
real(kind=4),parameter :: tlm0d=20.0 &                             !<-- center point longitudinal (E/W)
                         ,tph0d=35.0 &                             !<-- center point latitudinal (S/N)
                         ,wbd=-51.0 &                               !<-- western boundary (from center point)
                         ,sbd=-35.0 &                               !<-- southern boundary (from center point)
                         ,pt=5000.    &                               !<-- pressure at top of atmosphere
                         ,ptsgm=30000. &                           !<-- pressure sigma at toa
                         ,dlmd=0.30 &                              !<-- longitudinal grid resolution
                         ,dphd=0.30                                !<-- latitudinal grid resolution
!
!-----------------------------------------------------------------------
!***  model grid domain coordinates
!***  IMI,JMI,LM MUST AGREE WITH IM,JM,LM IN CONFIGFILE_GLOBAL
!-----------------------------------------------------------------------
!
integer(kind=4),parameter :: imi=341 &                             !<-- longitudinal mesh size
                            ,jmi=234 &                             !<-- latitudinal mesh size
                            ,im=341,jm=234 &                     !<-- mesh size with boundaries
                            ,lm=24 &                              !<-- horizontal model layers
!
!-----------------------------------------------------------------------
!***  additional grid parameters
!-----------------------------------------------------------------------
!
                            ,lnsh=1 &
                            ,lnsv=lnsh &
                            ,kms=4 &
                            ,ksnos=1 &
                            ,nosnos=kms-ksnos &
                            ,nwets=4
!
!-----------------------------------------------------------------------
!***  modelgrid.inc - END
!-----------------------------------------------------------------------
